/*3:*/
#line 9 "pperror.w"

#include "psimpoll.h"
#include "ppglobal.h"

/*:3*//*4:*/
#line 14 "pperror.w"

extern file_t outmain_f;

/*:4*//*65:*/
#line 207 "pperror.w"

void derror
(
int n
)

{
char ccode= ' ';

static const char*emess[]= 
{
/*25:*/
#line 77 "pperror.w"

"Input file was created by an early version of psimpoll and cannot be "
"used"
/*:25*/
#line 218 "pperror.w"
,
/*22:*/
#line 67 "pperror.w"

"getbuf: buffer is overfull. Check that individual input items do not "
"exceed\n159 characters. Then report problem to KDB"
/*:22*/
#line 219 "pperror.w"
,
/*26:*/
#line 81 "pperror.w"

"Input file is not a PostScript file"
/*:26*/
#line 220 "pperror.w"
,
/*39:*/
#line 120 "pperror.w"

"Sediment accumulation rate(s) have been calculated as negative\n"
"This will result in age reversals, and/or negative pollen\n"
"accumulation rates. Check output files for details, and\n"
"reconsider age model\n"
/*:39*/
#line 221 "pperror.w"
,
/*18:*/
#line 53 "pperror.w"

"First character of two-character code on line 4 of input must be\n"
"one of %, A, B, C, G, L, M, or X. See documentation for details.\n"
"The character in your file is "
/*:18*/
#line 222 "pperror.w"
,
/*42:*/
#line 132 "pperror.w"

"Second character of two-character code on line 4 of input must\n"
"be one of A, D, F, M, S, or T. See documentation for details. The\n"
"character in your file is "
/*:42*/
#line 223 "pperror.w"
,
/*58:*/
#line 181 "pperror.w"

"Check TS file: possible Troels-Smith symbol characters are Ld,\n"
"Lso, Th, Tbs, Sh, Tb, Hc, Hs, Ag, As, Ga, Gs, Dh, Tl, Lc, ptm, Dg,\n"
"Gg, Dl, Tep, los, lcs, Tuf\n"
/*:58*/
#line 224 "pperror.w"
,
/*62:*/
#line 195 "pperror.w"

"Error estimates on ages must be greater than zero, cannot complete"
" analysis.\nCheck values in C14 file"

/*:62*/
#line 225 "pperror.w"
,
/*21:*/
#line 64 "pperror.w"

"lfit (gaussj): singular matrix, cannot complete analysis"
/*:21*/
#line 226 "pperror.w"
,
/*50:*/
#line 158 "pperror.w"

"splint: bad xa[] input, cannot complete analysis. Check depths in C14 file"
/*:50*/
#line 227 "pperror.w"
,
/*55:*/
#line 172 "pperror.w"

"svdfit (svdcmp): zu() needs augmenting with extra zero rows, abnormal exit"
/*:55*/
#line 228 "pperror.w"
,
/*54:*/
#line 169 "pperror.w"

"svdfit (svdcmp): no convergence in 30 iterations of its, abnormal exit"
/*:54*/
#line 229 "pperror.w"
,
/*9:*/
#line 27 "pperror.w"

"bernshtein: failed to converge on a value for t after 10000 iterations"
/*:9*/
#line 230 "pperror.w"
,
/*34:*/
#line 102 "pperror.w"

"ran4: this function is somewhat non-portable\n"
"Output on your computer appears unreliable\n"
"Use one of the other random number generators"
/*:34*/
#line 231 "pperror.w"
,
/*13:*/
#line 39 "pperror.w"

"Unexpected end-of-file reached: data set is incomplete"
/*:13*/
#line 232 "pperror.w"
,
/*24:*/
#line 74 "pperror.w"

"indsplit: more than the allowed maximum of 20 splits found\n"
/*:24*/
#line 233 "pperror.w"
,
/*27:*/
#line 84 "pperror.w"

"Input box is greater than 63000 characters long"
/*:27*/
#line 234 "pperror.w"
,
/*35:*/
#line 107 "pperror.w"

"Rate of change analysis: the dissimilarity measure in use has exceeded "
"its theoretical maximum upper limit"
/*:35*/
#line 235 "pperror.w"
,
/*61:*/
#line 192 "pperror.w"

"Data set for analyses has zero samples"
/*:61*/
#line 236 "pperror.w"
,
/*40:*/
#line 126 "pperror.w"

"Script file (.SCR) not found: plotting will be interactive"
/*:40*/
#line 237 "pperror.w"
,
/*32:*/
#line 97 "pperror.w"

"Number of sum taxa is greater than 10"
/*:32*/
#line 238 "pperror.w"
,
/*5:*/
#line 18 "pperror.w"

"agedepth (timescale): failed to converge on a value for t after 10000 iterations"
/*:5*/
#line 239 "pperror.w"
,
/*29:*/
#line 90 "pperror.w"

"linint_s: two depths are identical or reversed"
/*:29*/
#line 240 "pperror.w"
,
/*49:*/
#line 155 "pperror.w"

"spline_s: two depths are identical or reversed"
/*:49*/
#line 241 "pperror.w"
,
/*41:*/
#line 129 "pperror.w"

"Unexpected end of script file"
/*:41*/
#line 242 "pperror.w"
,
/*12:*/
#line 36 "pperror.w"

"CA: residual bigger than tolerance"
/*:12*/
#line 243 "pperror.w"
,
/*57:*/
#line 178 "pperror.w"

"TILIA format: line-length unexpectedly short. Check input file!"
/*:57*/
#line 244 "pperror.w"

};

(void)fputc('\n',stderr);

if(n==4)ccode= gl.code.dat;
if(n==5)ccode= gl.code.yax;

(void)fprintf(stderr,"%s%c\n",emess[n],ccode);

if(n==0||n==2||n==6||n==19||n==21||n==24)return;

if(n==3)return;

(void)fprintf(stderr,"Program ending\n");

EXIT(EXIT_FAILURE);
}

/*:65*//*67:*/
#line 270 "pperror.w"

void lerror
(
int n
)

{
static const char*emess[]= 
{
/*28:*/
#line 87 "pperror.w"

"int conversion: floating point number cannot be represented as integer"
/*:28*/
#line 279 "pperror.w"
,
/*15:*/
#line 44 "pperror.w"

"fclose: error in closing a file"
/*:15*/
#line 280 "pperror.w"
,
"",
/*11:*/
#line 33 "pperror.w"

"calloc: memory allocation error"
/*:11*/
#line 282 "pperror.w"
,
/*20:*/
#line 61 "pperror.w"

"fscanf: unexpected end of file"
/*:20*/
#line 283 "pperror.w"
,
/*16:*/
#line 47 "pperror.w"

"fgetc: no character read (end of file?)"
/*:16*/
#line 284 "pperror.w"
,
/*17:*/
#line 50 "pperror.w"

"fgets: no string read (end of file?)"
/*:17*/
#line 285 "pperror.w"
,
/*23:*/
#line 71 "pperror.w"

"getc: reading error (end of file?)"
/*:23*/
#line 286 "pperror.w"
,
/*19:*/
#line 58 "pperror.w"

"fopen: failed to open file"
/*:19*/
#line 287 "pperror.w"
,
/*56:*/
#line 175 "pperror.w"

"switch: unexpected value"
/*:56*/
#line 288 "pperror.w"
,
/*51:*/
#line 161 "pperror.w"
"sqrt"
/*:51*/
#line 289 "pperror.w"
,
/*31:*/
#line 95 "pperror.w"
"log"
/*:31*/
#line 290 "pperror.w"
,
/*30:*/
#line 93 "pperror.w"
"log10"
/*:30*/
#line 291 "pperror.w"
,
/*52:*/
#line 163 "pperror.w"

"strcat: total string length too long"
/*:52*/
#line 292 "pperror.w"
,
/*8:*/
#line 25 "pperror.w"
"atan2"
/*:8*/
#line 293 "pperror.w"
,
"dtof: float-to-double conversion is not possible",
/*36:*/
#line 111 "pperror.w"

"realloc: attempt to reallocate to a negative amount of space"
/*:36*/
#line 295 "pperror.w"
,
/*37:*/
#line 114 "pperror.w"

"realloc: memory allocation error"
/*:37*/
#line 296 "pperror.w"
,
/*6:*/
#line 21 "pperror.w"
"asin"
/*:6*/
#line 297 "pperror.w"
,
/*7:*/
#line 23 "pperror.w"
"atan"
/*:7*/
#line 298 "pperror.w"
,
/*33:*/
#line 100 "pperror.w"
"pow"
/*:33*/
#line 299 "pperror.w"
,
/*14:*/
#line 42 "pperror.w"
"exp"
/*:14*/
#line 300 "pperror.w"
,
/*59:*/
#line 186 "pperror.w"

"ungetc: error pushing character back"
/*:59*/
#line 301 "pperror.w"
,
/*38:*/
#line 117 "pperror.w"

"scanf: input failure"
/*:38*/
#line 302 "pperror.w"
,
"sprintf: too many characters copied",
/*10:*/
#line 30 "pperror.w"

"time: calendar time not available"
/*:10*/
#line 304 "pperror.w"
,
/*53:*/
#line 166 "pperror.w"

"strftime: failed to fill array"
/*:53*/
#line 305 "pperror.w"
,
/*60:*/
#line 189 "pperror.w"

"vprintf/vfprintf: output error"
/*:60*/
#line 306 "pperror.w"

};


(void)fputc('\n',stderr);

STRERROR;

(void)fprintf(stderr,"%s\n",emess[n]);
(void)fprintf(stderr,"Program ending\n");

EXIT(EXIT_FAILURE);
}


/*:67*//*69:*/
#line 335 "pperror.w"

void handler
(
int sig
)

{

(void)fputc('\n',stderr);

STRERROR;

if(sig!=SIGINT)
{
(void)fprintf(stderr,"Fatal error detected by operating system: "
"please report to KDB\n");
}

switch(sig)
{
case SIGABRT:
(void)fprintf(stderr,/*43:*/
#line 137 "pperror.w"

"SIGABRT: Abnormal termination\n"
/*:43*/
#line 356 "pperror.w"
);
break;
case SIGFPE:
(void)fprintf(stderr,/*44:*/
#line 140 "pperror.w"

"SIGFPE: Floating point exception\n"
/*:44*/
#line 359 "pperror.w"
);
break;
case SIGILL:
(void)fprintf(stderr,/*45:*/
#line 143 "pperror.w"

"SIGILL: Invalid function image\n"
/*:45*/
#line 362 "pperror.w"
);
break;
case SIGINT:
(void)fprintf(stderr,/*46:*/
#line 146 "pperror.w"

"\nSIGINT: interactive attention signal from user\n"
/*:46*/
#line 365 "pperror.w"
);
break;
case SIGSEGV:
(void)fprintf(stderr,/*47:*/
#line 149 "pperror.w"

"SIGSEGV: Invalid access to storage\n"
/*:47*/
#line 368 "pperror.w"
);
break;
case SIGTERM:
(void)fprintf(stderr,/*48:*/
#line 152 "pperror.w"

"SIGTERM: Termination request received\n"
/*:48*/
#line 371 "pperror.w"
);
break;
}

(void)fprintf(stderr,"Program ending\n");

EXIT(EXIT_FAILURE);
}


/*:69*//*71:*/
#line 386 "pperror.w"

void ppend
(
void
)

{
real elapsetime= 0;
clock_t clockend;

rtn= fprintf(gl.logf.fp,"%d program files remain open\n",
gl.openfiles-3);
assert(rtn>0);

dprint(&gl.logf,"%s\n",getctime());


clockend= clock();
elapsetime= ((real)(clockend-gl.clockstart))/CLOCKS_PER_SEC;

if(elapsetime<0)elapsetime+= 86400L;
rtn= printf("Running time %.2fs\n",elapsetime);
assert(rtn>0);


if(fclose(gl.logf.fp)!=0)PPERROR(1);

#ifdef WIN95

dlay();
#endif

return;
}
/*:71*/
