/*3:*/
#line 14 "ppfuncx1.w"

#include "psimpoll.h"
#include "ppglobal.h" 
#include "ppfunc1.h" 
#include "ppfunc2.h" 
#include "ppps.h" 
#include "ppscreen.h" 


/*:3*//*4:*/
#line 24 "ppfuncx1.w"

extern const char*opertext_f[9];
extern file_t outmain_f;

/*:4*//*5:*/
#line 29 "ppfuncx1.w"

static char buffer_f[LENSTR2];

/*:5*//*6:*/
#line 33 "ppfuncx1.w"

/*11:*/
#line 129 "ppfuncx1.w"

static void joincurve_s(real xlev,real yplot,real xlevold,real yplotold,
frame_t ind);
/*:11*//*23:*/
#line 398 "ppfuncx1.w"

static void getconci_s(const conc_t conc,const int j,float poll,
const int signif,real*const dlow,real*const dhigh,const sed_t sed,
const int nci);
/*:23*//*27:*/
#line 562 "ppfuncx1.w"

static void getperci_s(float poll,float fq,const int signif,
real*const dlow,real*const dhigh);
/*:27*/
#line 34 "ppfuncx1.w"


/*:6*//*8:*/
#line 42 "ppfuncx1.w"

void confcurve_x
(
real xlev,
real**yplotex,
const int j,
real yplot,
real xlevold,
real yplotold,
frame_t ind
)

{
psgoto('m',xlev,yplotex[0][j]*gl.page.minpl);
if(gl.tufte==ON&&yplot>0)
{

psgoto('l',xlev,yplotex[2][j]*gl.page.minpl);

PSOPER(3);
PSCIRCLE(xlev,yplot*gl.page.minpl,10);

psgoto('m',xlev,yplotex[3][j]*gl.page.minpl);
}

psgoto('l',xlev,yplotex[1][j]*gl.page.minpl);

if(gl.tufte==OFF)
{

psgoto('m',xlev,yplot*gl.page.minpl);
if(xlevold>=0)
{
joincurve_s(xlev,yplot,xlevold,yplotold,ind);
}

}

return;
}


/*:8*//*10:*/
#line 90 "ppfuncx1.w"

void histcurve_x
(
real xlev,
real histwid,
real yplot,
real levdiff,
frame_t*ind,
frame_t coll
)

{

if(coll.curve==HIST&&ind->curve==HIST)
{
ind->hist= (histwid/levdiff)*gl.page.prop;
ind->hist/= 2;
}

psgoto('m',xlev+ind->hist,0);

psgoto('l',xlev+ind->hist,yplot*gl.page.minpl);
psgoto('l',xlev-ind->hist,yplot*gl.page.minpl);

psgoto('l',xlev-ind->hist,0);
if(ind->style==OUTL)PSOPER(3);
else if(ind->style==FILL)
{
psgoto('l',xlev+ind->hist,0);
psgray(outmain_f.fp,1.0-ind->shade,ind->colpl,1);
psgray(outmain_f.fp,1.0,ind->colpl,0);
}

return;

}

/*:10*//*12:*/
#line 133 "ppfuncx1.w"

static void joincurve_s
(
real xlev,
real yplot,
real xlevold,
real yplotold,
frame_t ind
)

{
psgoto('l',xlevold,yplotold*gl.page.minpl);
if(ind.style==OUTL)PSOPER(3);
else if(ind.style==FILL)
{
psgoto('l',xlevold,0);
psgray(outmain_f.fp,1.0-ind.shade,ind.colpl,1);
psgray(outmain_f.fp,1.0,ind.colpl,0);
pslineto(1,xlev,yplot*gl.page.minpl,xlevold-xlev,
(yplotold-yplot)*gl.page.minpl);
}

return;
}


/*:12*//*14:*/
#line 165 "ppfuncx1.w"

void numbcurve_x
(
real xlev,
frame_t ind,
float number,
flag_t*igap,
int nsam,
flag_t sum2col
)

{
real fdummy1= 0;
real fdummy2= 0;

rtn= sprintf(buffer_f,"%d",(int)number);
assert(rtn>0&&rtn<LENSTR2);
if(*igap==OFF)
{
pstext(outmain_f.fp,6,xlev+gl.page.lineht/2,
gl.page.sep/2,buffer_f,"F2",ANG);
}
else
{
fdummy1= xlev+gl.page.lineht/2;
fdummy2= (gl.page.sep+(ind.max*gl.page.minpl))/2;
pstext(outmain_f.fp,6,fdummy1,fdummy2,buffer_f,"F2",ANG);
}

if(nsam>50||sum2col==ON)toggle(&*igap);

return;
}

/*:14*//*16:*/
#line 205 "ppfuncx1.w"

void plaicurve_x
(
real xlev,
real yplot,
real xlevold,
real yplotold,
frame_t ind
)

{

psgoto('m',xlev,0);

psgoto('l',xlev,yplot*gl.page.minpl);

if(xlevold>=0)joincurve_s(xlev,yplot,xlevold,yplotold,ind);

return;

}


/*:16*//*18:*/
#line 234 "ppfuncx1.w"

void summcurve_x
(
real xlev,
real**yplotex,
const int j,
real yplot,
real xlevold,
real*yplotold,
summary_t summary,
const frame_t ind
)

{
loop_t l= 0;

real oyhigh= 0;
real oylow= 0;
real yhigh= 0;
real ylow= 0;

psgoto('m',xlev,0);
if(xlevold>=0)
{
for(l= 0;l<summary.n;l++)
{
if(l==0)
{
ylow= 0;
oylow= 0;
yhigh= yplot*gl.page.minpl;
oyhigh= yplotold[l]*gl.page.minpl;
}
else
{
ylow= yhigh;
oylow= oyhigh;
yhigh= yplotex[l-1][j]*gl.page.minpl;
oyhigh= yplotold[l]*gl.page.minpl;
psgoto('m',xlev,ylow);
}

psgoto('l',xlev,yhigh);
psgoto('l',xlevold,oyhigh);
psgoto('l',xlevold,oylow);
psgray(outmain_f.fp,
summary.colid[l]<0&&ind.colpl==0?0.0:1.0-summary.grey[l],
ind.colpl>0?-ind.colpl:summary.colid[l],1);

}

}

return;

}


/*:18*//*20:*/
#line 303 "ppfuncx1.w"

void datasc_x
(
const real x,
frame_t*const f
)

{
real a= 0;
int n= 0;

if(x<=0)f->scale= f->finscale= 1;
else
{
n= int3(log10e(x));
f->scale= powe(10,-((real)n-1));
a= x*f->scale;

if(a>=50)f->finscale= 1;
else if(a>=20)f->finscale= 2;
else if(a>=10)f->finscale= 5;
else f->finscale= 10;
}

return;
}

/*:20*//*22:*/
#line 337 "ppfuncx1.w"

void fillscreen_x
(
char**const taxname,
const int ntax,
int*const nchar,
int*const nltax,

int*const npage,
int*const nrow
)

{
const char*opttext= 
"Enter 'Q', 'N', or 'number[Bx][Cx][D][E][F][Gx][Hx][O][Px][Sx][T][X]'";

loop_t k= 0;

buffer_f[0]= '\0';


cls(scline_f,3,SCRHT-2);
*nchar= 6;
if(ntax>110)*nchar= 3;
if(ntax>152)*nchar= 0;
*nltax= 79/(*nchar+5);
*nrow= 3;

while(k<ntax)
{

rtn= sprintf(buffer_f," %3d ",k);
assert(rtn>0&&rtn<LENSTR);
vstrcat(SCRWID,scline_f[*nrow],buffer_f,(char*)NULL);


shortstr(buffer_f,taxname[k],*nchar+1);


vstrcat(SCRWID,scline_f[*nrow],buffer_f,(char*)NULL);

if(pstrlen(scline_f[*nrow])>=(SCRWID-(5+*nchar)))(*nrow)++;

k++;

}

(*nrow)+= 2;
if(*nrow<SCRHT)pstrcpy(scline_f[*nrow],opttext,SCRWID);
*npage= (*nrow)+2;
(*nrow)+= 3;

return;
}


/*:22*//*24:*/
#line 403 "ppfuncx1.w"

static void getconci_s
(
const conc_t conc,
const int j,
float poll,
const int signif,
real*const dlow,
real*const dhigh,
const sed_t sed,
const int nci
)


{
real alogsar= 0;
real alogsr= 0;
real alogssar= 0;
real algsarmax= 0;
real algsarmin= 0;
real arm= 0;
real armax= 0;
real armin= 0;
real asdl= 0;
real asdu= 0;
real part1= 0;
real part2= 0;
real part3= 0;
real nsd= 0;





if(signif==95)nsd= 1.96;
else if(signif==65)nsd= 1.0;

arm= (real)poll*conc.ex[5][j]/(conc.ex[0][j]*conc.ex[2][j]);
if(gl.code.dat=='B')arm*= sed.ar[j];

if(arm*conc.ex[4][j]<4||conc.ex[4][j]<100)
{
*dlow= MAX((real)0,(real)poll);
*dhigh= MAX((real)0,(real)poll);
}
else
{
part1= arm+(1/(2*conc.ex[4][j]));
part2= sqrte((arm*(1+arm)/conc.ex[4][j])+
(1/(4*conc.ex[4][j]*conc.ex[4][j])));
part3= 1-(1/conc.ex[4][j]);
armax= (part1+part2)/part3;
armin= (part1-part2)/part3;

if(nci==1)
{
alogsr= (log10e(armax)-log10e(armin))/2;
alogsr*= alogsr;
if(gl.code.dat!='B')alogssar= alogsar= 0;
else
{
algsarmax= log10e(sed.ar[j]+sed.arsd[j]);
algsarmin= log10e(sed.ar[j]-sed.arsd[j]);
alogssar= (algsarmax-algsarmin)/2;
alogssar*= alogssar;
alogsar= log10e(sed.ar[j]);
}
part1= nsd*sqrte(alogsr+conc.lgsmv[j]+alogssar);
part2= log10e(arm)+conc.lgmv[j]-alogsar;
*dlow= powe(10,part2-part1);
*dhigh= powe(10,part2+part1);
}
else if(nci==2)
{
asdl= errprop2(arm,part1-armin,conc.mv[j],conc.mvsd[j]);
asdu= errprop2(arm,armax-part1,conc.mv[j],conc.mvsd[j]);
if(gl.code.dat=='B')
{
asdl= errprop3(arm*conc.mv[j],asdl,sed.ar[j],sed.arsd[j]);
asdu= errprop3(arm*conc.mv[j],asdu,sed.ar[j],sed.arsd[j]);
}
*dlow= (real)poll-nsd*asdl;
*dhigh= (real)poll+nsd*asdu;

}

}

return;
}


/*:24*//*26:*/
#line 501 "ppfuncx1.w"

char*getfoot_x
(
const real ascale,
const char*const sx,
char sunit[12][LENSTR/2]
)

{
static char text[LENSTR]= "";

int leng= 0;
int nl= 0;

if(gl.code.dat=='%'&&pstrlen(sx)==0)
{
pstrcpy(text,"%",LENSTR);
}
else pstrcpy(text,sx,LENSTR);

leng= int2(log10e(1/ascale));
if(leng<0||leng>1)
{

vstrcat(LENSTR,text,mkstr("\\327 10{%d}",leng),(char*)NULL);
}
else if(leng==1)
{
vstrcat(LENSTR,text,mkstr("\\327 10"),(char*)NULL);
}

switch(gl.code.dat)
{
case'C':
nl= 1;
break;
case'G':
nl= 2;
break;
case'A':case'B':
nl= 3;
break;
case'L':
nl= 12;
break;
case'X':case'%':case'M':
break;
default:
PPERROR(9);
}

if(nl>0)(void)strcat(text,sunit[nl-1]);

return(text);
}


/*:26*//*28:*/
#line 566 "ppfuncx1.w"

static void getperci_s
(
float poll,
float fq,
const int signif,
real*const dlow,
real*const dhigh
)

{
real p= 0;
real q= 0;
real part1= 0;
real part2= 0;
real part3= 0;
real nsd= 0;
real sqnsd= 0;

if(signif==95)nsd= 1.96;
else if(signif==65)nsd= 1.0;
sqnsd= SQUARE(nsd);

if(poll<=0)
{

*dlow= 0;
*dhigh= 0;
}
else
{
p= (real)poll/100;
q= (real)fq;
part1= p+(sqnsd/(2*q));
part2= nsd*sqrte((p*(1-p)/q)+(sqnsd/(4*q*q)));
part3= 1+(sqnsd/q);
part1*= (100/part3);
part2*= (100/part3);
*dlow= part1-part2;
*dhigh= part1+part2;
}

return;
}

/*:28*//*30:*/
#line 616 "ppfuncx1.w"

void logcoll_x
(
const frame_t c
)

{
const char*const buff1[]= 
{
"PLAIN","SUMMARY","CONFIN","NUMBER","HIST"
};

const char*const buff2[]= {"OUTL","FILL"};
const char*const buff3[]= {"OFF","ON"};
const char*const buff4[]= {"WRITE","READ"};

TOLOGS2(c.all,buff3[abs((int)c.all)]);
TOLOGS2(c.bars,buff3[abs((int)c.bars)]);
TOLOGS2(c.bull,buff3[abs((int)c.bull)]);
TOLOGF(c.lval);
TOLOGS2(c.exchar,buff3[abs((int)c.exchar)]);
TOLOGS2(c.ix10,buff3[abs((int)c.ix10)]);
TOLOGS2(c.indscale,buff3[abs((int)c.indscale)]);
TOLOGS2(c.indspl,buff3[abs((int)c.indspl)]);
TOLOGS2(c.join,buff3[abs((int)c.join)]);
TOLOGS2(c.label,buff3[abs((int)c.label)]);
TOLOGS2(c.style,buff2[(int)c.style]);
TOLOGF(c.shade);
TOLOGS2(c.curve,buff1[(int)c.curve]);
TOLOGF(c.scale);
TOLOGF(c.finscale);
TOLOGF(c.max);
TOLOGF(c.min);
TOLOGS2(c.ulimit,buff3[abs((int)c.ulimit)]);
TOLOGI(c.rot);
TOLOGF(c.hist);
TOLOGS2(c.script,buff4[(int)c.script]);
TOLOGS2(c.sum2col,buff3[abs((int)c.all)]);
TOLOGI(c.skip);
TOLOGF(c.datamax);
TOLOGF(c.datamin);
TOLOGF(c.median);
TOLOGF(c.lq);
TOLOGF(c.uq);
TOLOGS2(c.c14scale,buff3[abs((int)c.c14scale)]);
TOLOGS2(c.interp,buff3[abs((int)c.interp)]);
TOLOGL(c.colpl);
TOLOGL(c.coltit);
TOLOGL(c.coldep);
TOLOGL(c.col14c);
TOLOGL(c.colts);
TOLOGL(c.colzone);
TOLOGL(c.colxax);
TOLOGL(c.colsdpl);
TOLOGF(c.penwid);

return;
}


/*:30*//*32:*/
#line 683 "ppfuncx1.w"

void obtpmax_x
(
const data_t data,
frame_t*const ind,
const int itax,
const int itaxty,
real**yplotex,
int*const nsum,
const sed_t sed,
const int nci,
file_t*const stat
)

{
real dummy= 0;

int plotsam= 0;
int nosm= 0;

loop_t j= 0;
loop_t l= 0;

real*plotdata= NULL;

plotdata= avecreal(data.nsam);

buffer_f[0]= '\0';

ind->datamax= (real)0;
ind->datamin= (gl.tufte==ON?FLT_MAX:(real)0);

if(ind->curve==CONFIN&&itaxty!='!')
{
rtn= fprintf(stat->fp,"%s: 95%% confidence intervals\n",
data.taxname[itax]);
assert(rtn>0);
}

for(j= 0;j<data.nsam;j++)
{
if(data.levfg[j]==OFF&&ind->all==OFF)continue;

if(gl.tufte==ON&&data.dat[itax][j]>(float)gl.neglev)
{
plotdata[plotsam++]= (real)data.dat[itax][j];
}


if(ind->curve==CONFIN)
{
if(itaxty=='!')
{


yplotex[0][j]= (real)data.dat[data.ntax+1][j];
yplotex[1][j]= (real)data.dat[data.ntax+2][j];
ind->max= MAX(ind->max,yplotex[1][j]);
if(yplotex[0][j]>gl.neglev)ind->min= MIN(ind->min,yplotex[0][j]);
}
else
{

switch(gl.code.dat)
{
case'%':
for(;;)
{
if(itax<nsum[nosm])
{
getperci_s(data.dat[itax][j],data.dat[nsum[nosm]][j],95,
&yplotex[0][j],&yplotex[1][j]);
if(gl.tufte==ON)
{

getperci_s(data.dat[itax][j],data.dat[nsum[nosm]][j],65,
&yplotex[2][j],&yplotex[3][j]);
}

rtn= fprintf(stat->fp,"%f %f %f\n",data.dat[itax][j],
yplotex[0][j],yplotex[1][j]);
assert(rtn>0);

break;
}
if(nsum[nosm]==0)
{

rtn= fputs("No sum found to calculate confidence intervals\n",
gl.logf.fp);
assert(rtn!=EOF);
ind->curve= PLAIN;
ind->max= MAX(ind->max,(real)data.dat[itax][j]);
break;
}
nosm++;

}

break;

case'B':case'C':
getconci_s(data.conc,j,data.dat[itax][j],95,&yplotex[0][j],
&yplotex[1][j],sed,nci);
if(gl.tufte==ON)
{
getconci_s(data.conc,j,data.dat[itax][j],65,&yplotex[2][j],
&yplotex[3][j],sed,nci);
}

rtn= fprintf(stat->fp,"%f %f %f\n",data.dat[itax][j],
yplotex[0][j],yplotex[1][j]);
assert(rtn>0);
break;
default:
ind->curve= PLAIN;
ind->max= MAX(ind->max,(real)data.dat[itax][j]);
break;

}

if(ind->curve==CONFIN)
{
ind->max= MAX(ind->max,yplotex[1][j]);
if(data.dat[itax][j]>(float)gl.neglev)
{
ind->min= MIN(ind->min,yplotex[0][j]);
}

}

}

}

else if(ind->curve==NUMBER)
{
rtn= sprintf(buffer_f,"%d",(int)data.dat[itax][j]);
assert(rtn>0&&rtn<LENSTR);
dummy= strwid("0")*((real)pstrlen(buffer_f)+1)/gl.page.minpl;
ind->max= MAX(ind->max,dummy);
}

else if(ind->curve==SUMMARY)
{


for(l= 0;l<(data.summary.n-1);l++)
{
yplotex[l][j]= (real)data.dat[data.ntax+l+3][j];
}

ind->max= 100;

}

else
{
ind->max= MAX(ind->max,(real)data.dat[itax][j]);
if(data.dat[itax][j]>(float)gl.neglev)
{
ind->min= MIN(ind->min,(real)data.dat[itax][j]);
}

}

}

if(gl.tufte==ON)
{
qsort(plotdata,plotsam,sizeof(real),compare);
ind->datamax= plotdata[plotsam-1];
ind->datamin= plotdata[0];
quart(&ind->lq,&ind->median,&ind->uq,plotdata,plotsam);
}

if(ind->curve==NUMBER&&data.nsam>50)ind->max*= 2;

if(ind->ulimit==ON)
{
real oldmax= 0.0;
real oldmin= 0.0;
oldmax= ind->max;
oldmin= ind->min;
rtn= sprintf(scline_f[SCRHT-2],
"Current maximum value for taxon '%d' is '%.4f': enter new value "
"<Enter>",itax,oldmax);
assert(rtn>0&&rtn<SCRWID);
psc(scline_f);
ind->max= getsing(oldmax,1e7);
rtn= sprintf(scline_f[SCRHT-2],
"Current minimum value for taxon '%d' is '%.4f': enter new value "
"<Enter>",itax,oldmin);
assert(rtn>0&&rtn<SCRWID);
psc(scline_f);
ind->min= getsing(gl.neglev,oldmin);
scline_f[SCRHT-2][0]= '\0';
}

fvec(plotdata);

return;
}


/*:32*//*34:*/
#line 894 "ppfuncx1.w"

void maindepax_x
(
int n,




const flag_t agetimx,
const int rot,
const caption_t head,
const samp_t lev,
const xaxis_t xaxis,
frame_t coll
)

{
real fdummy2= 0;
real leng= 0;
real qyy= 0;
real val= 0;

loop_t j= 0;
loop_t m= 0;

buffer_f[0]= '\0';

if(!agetimx)
{
rtn= sprintf(buffer_f,"n %s",n==1?"LSSc":"RSSc");
assert(rtn>0&&rtn<10);
}
else
{
rtn= sprintf(buffer_f,"n LTSc");
assert(rtn>0&&rtn<10);
}

PSCOMM(buffer_f);


pscolour(outmain_f.fp,coll.coldep);
PSPEN2(outmain_f.fp,coll.penwid);

if(gl.code.yax=='T')n+= 2;

if(n==1)
{

leng= MAX(gl.page.yscbeg,xaxis.leng);
pstran(0.0F,leng);
qyy= gl.page.sep;
m= 7;
}

else if(n==2||n==4)
{
fdummy2= 2*gl.page.sep+gl.page.zon;
pstran(0.0F,fdummy2);
qyy= -gl.page.sep;
m= 6;
}

if(n<=2)pslineto(0,DIAGOFF,0,gl.page.prop,0);

if(n!=3)
{

for(j= 0;j<xaxis.ntick;j++)
{

val= DIAGOFF+((xaxis.val[j]-lev.min)/(lev.ex-lev.min))*
gl.page.prop;

assert(xaxis.annot[j]!=NULL);
if(pstrlen(xaxis.annot[j])==0)
{

pslineto(0,val,0,0,qyy/2);
}
else
{

PSOPER(3);
pstext(outmain_f.fp,m,val+(gl.page.lineht/2),-qyy,xaxis.annot[j],"F2",
ANG);
pslineto(0,val,0,0,qyy);
}

}

PSOPER(3);

}

if(n!=1&&n!=3)pstran(0,gl.page.yscbeg+gl.page.sep);
else if(n==1||n==3)
{
if(!agetimx)
{

leng= strwid(head.ps1);
pstext(outmain_f.fp,6,LAB1OFF,-0.015F-leng/2,head.ps1,"F2",ANG);
leng= strwid(head.ps2);
pstext(outmain_f.fp,6,LAB2OFF,-0.015F-leng/2,head.ps2,"F2",ANG);
}
else
{

pstext(outmain_f.fp,6,NAMEOFF,-leng,head.time,"F2",ANG+rot);
gl.page.time= leng+(2*gl.page.sep);
}

pstran(0,2*gl.page.sep);

}


pscolour(outmain_f.fp,gl.palette.fore);

return;
}

/*:34*/
