/*6:*/
#line 41 "ppps.w"

#if !defined PPMAIN
extern file_t outmain_f;
extern file_t inmain_f;
#endif

/*:6*//*7:*/
#line 48 "ppps.w"


#define PSCIRCLE(x, y, r)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "%ld %ld %d 0 360 a f\n",\
        (long)(gl.page.xmg + (x) * gl.page.high),\
        (long)((y) * gl.page.wide), r);\
    assert(rtn > 0);\
  } while(0)


#define PSCOMM(string)\
  do \
  {\
    if (outmain_f.fp != NULL)\
    {\
      rtn =  fprintf(outmain_f.fp, "%%%s\n", string);\
      assert(rtn > 0);\
    }\
  } while(0)


#define PSCOMM2(filep, string)\
  do \
  {\
    if (filep != NULL)\
    {\
      rtn =  fprintf(filep, "%%%s\n", string);\
      assert(rtn > 0);\
    }\
  } while(0)


#define PSDASH(i, j)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "[%d %d] 0 setdash\n", i, j);\
    assert(rtn > 0);\
  } while(0)


#define PSNODASH \
  do \
  {\
    rtn =  fputs("[] 0 setdash\n", outmain_f.fp);\
    assert(rtn != EOF);\
  } while(0)


#define PSOPER(n) (void)fprintf(outmain_f.fp, "%s\n", opertext_f[n])


#define PSOPER2(filep, n) if (filep != NULL) (void)fprintf(filep, "%s\n", opertext_f[n])


#define PSPEN(x)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "%.1f sl\n", (x));\
    assert(rtn > 0);\
  } while(0)


#define PSPEN2(filep, x)\
  do \
  {\
    if (filep != NULL)\
    {\
      rtn =  fprintf(filep, "%.1f sl\n", (x));\
      assert(rtn > 0);\
    }\
  } while(0)


#define PSPTRAN(x, y)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "%ld %ld tr\n", (long)(x), (long)(y));\
    assert(rtn > 0);\
  } while(0)


#define PSPTRAN2(filep, x, y)\
  do \
  {\
    if (filep != NULL)\
    {\
      rtn =  fprintf(filep, "%ld %ld tr\n", (long)(x), (long)(y));\
      assert(rtn > 0);\
    }\
  } while(0)


#define PSROT(n)\
 do \
 {\
   rtn =  fprintf(outmain_f.fp, "%d r\n", n);\
    assert(rtn > 0);\
  } while(0)


#define PSROT2(filep, n)\
 do \
 {\
   if (filep != NULL)\
   {\
     rtn =  fprintf(filep, "%d r\n", n);\
     assert(rtn > 0);\
   }\
 } while(0)


#define PSSCALE(x, y)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "%f %f sc\n", x, y);\
    assert(rtn > 0);\
  } while(0)


#define PSSYM(string)\
  do \
  {\
    rtn =  fprintf(outmain_f.fp, "%s ", string);\
    assert(rtn > 0);\
  } while(0)


/*:7*//*18:*/
#line 363 "ppps.w"

void pscolour(FILE*fp,const long id);
/*:18*//*22:*/
#line 430 "ppps.w"

void psgoto(const char r,const real x,const real y);
/*:22*//*24:*/
#line 452 "ppps.w"

void psgoto2(FILE*filep,const char r,const real x,const real y);
/*:24*//*26:*/
#line 480 "ppps.w"

void psgray(FILE*filep,real gray,const long id,const int n);
/*:26*//*30:*/
#line 779 "ppps.w"

void pslineto(const int n,const real x,const real y,const real xx,
const real yy);
/*:30*//*32:*/
#line 803 "ppps.w"

void pslineto2(FILE*fp,const int n,const real x,const real y,
const real xx,const real yy);
/*:32*//*38:*/
#line 955 "ppps.w"

void pstran(const real x,const real y);
/*:38*//*40:*/
#line 984 "ppps.w"

void pstran2(FILE*filep,const real x,const real y);
/*:40*//*47:*/
#line 1218 "ppps.w"

void pstext(FILE*filep,const int i,const real x,const real y,
const char*const intext,const char*const font1,const int m);
/*:47*/
