/*2:*/
#line 8 "pscomb.w"

#include "psimpoll.h"
#include "ppmenu.h"
#include "ppps.h" 

#define INITGLOBAL
#include "ppglobal.h" 


/*:2*//*3:*/
#line 18 "pscomb.w"

/*7:*/
#line 52 "pscomb.w"

int main(int argc,char*argv[]);
/*:7*//*10:*/
#line 577 "pscomb.w"

static void cmenu_s(const char*const menustr[18],file_t*outmain_f,
char**infile,int*nargc,flag_t*intfg,char*base,char*title);
/*:10*//*12:*/
#line 646 "pscomb.w"

static void cmenue_s(const char*const menustr,file_t*outmain_f,char**infile,
int*nargc);
/*:12*//*14:*/
#line 712 "pscomb.w"

static void cmenui_s(const char*const menustr,char*base,char*title);
/*:14*/
#line 19 "pscomb.w"


/*:3*//*4:*/
#line 22 "pscomb.w"

char**scline_f= NULL;
char**sclineb_f= NULL;
char**sclinec_f= NULL;

file_t outmain_f= 
{
"",NULL,CLOSED,"w"
};

file_t inmain_f= 
{
"",NULL,CLOSED,"r"
};

/*:4*//*5:*/
#line 38 "pscomb.w"

extern const char*entnumline_f;
extern const char*quitline_f;
extern const char*switchline_f;
extern const char*sfmt_f;
extern const char*dfmt_f;
extern const char*ffmt_f[4];

/*:5*//*6:*/
#line 47 "pscomb.w"

static char buffer_f[LENSTR2];

/*:6*//*8:*/
#line 55 "pscomb.w"

int main
(
int argc,
char*argv[]
)

{

char base[LENSTR]= "";
char buffer[LENSTR2]= "";
static const char*const menustr[18]= 
{
"A",
"B",
"C",
"D",
"E Change or enable files",
"F Font family (Helvetica)",
"G Size of selected font ",
"H",
"I Add/change titles",
"J",
"K Interactive plotting (on)",
"L",
"M",
"N",
"O",
"P",
"U Utilities",
"X Run program"
};
char name[10]= "";
char**box= NULL;
char**boxname= NULL;
char**infile= NULL;
char rkey[10]= "";

char title[LENSTR]= "";

flag_t boxflag= OFF;
flag_t ignflag= ON;
flag_t intfg= ON;
flag_t newpge= OFF;

real asize= 250.0/7.1;
real ylo= 0;

real*boxwid= NULL;

int ibox= 0;
int ilbox= 0;
int ipge= 0;
int mem= 50;
int nargc= 0;
int nbox= -1;
int nchar= 0;
int nfile= 1;
int nlbox= 0;
int npage= 0;
int nrow= 0;

int startfile[20];
long*boxlen= NULL;

loop_t i= 0;
loop_t k= 0;
loop_t n= 0;

file_t Stdin= 
{
"stdin",NULL,OPEN,""
};


(void)signal(SIGABRT,handler);
(void)signal(SIGILL,handler);
(void)signal(SIGINT,handler);
(void)signal(SIGFPE,handler);
(void)signal(SIGSEGV,handler);
(void)signal(SIGTERM,handler);


gl.clockstart= clock();

ATEXIT(&ppend);

Stdin.fp= stdin;


#ifdef MPW
(void)setbuf(stdout,(char*)NULL);
#endif


pstrcpy(gl.prog,"pscomb",10);
gl.ver= 1.03;
pstrcpy(gl.logf.fname,"pscomb.LOG",LENFNAME);


if((gl.logf.fp= fopen(gl.logf.fname,"w"))==NULL)PPERROR(8);
gl.logf.st= OPEN;
#ifdef MPW
rtn= setvbuf(gl.logf.fp,(char*)NULL,_IONBF,BUFSIZ);
assert(rtn==0);
#endif
rtn= fprintf(gl.logf.fp,"%s\n",getctime());
assert(rtn>0);




gl.page.high= gl.page.wide/ROOT2;
gl.page.prop= 12700/gl.page.high;
gl.page.ymg= (gl.papwid-gl.page.high)*0.5;
gl.page.xmg= (gl.papht-gl.page.wide)*0.5;
ylo= gl.page.xmg;

scline_f= amatchar(SCRHT,SCRWID);
sclineb_f= amatchar(SCRHT,SCRWID);


(void)sprintf(scline_f[1],"%s %.2f",gl.prog,gl.ver);
pstrcpy(sclineb_f[1],scline_f[1],SCRWID);
pstrcpy(scline_f[SCRHT-1],"> ",SCRWID);
pstrcpy(sclineb_f[SCRHT-1],scline_f[SCRHT-1],SCRWID);



rtn= printf("\n\n%s %.2f Copyright (c) 1993, 1998 K.D. Bennett\n\n",gl.prog,
gl.ver);
assert(rtn>0);


pstrcpy(outmain_f.fname,"comb.ps",LENFNAME);


infile= amatchar(10,LENFNAME);
nargc= 0;
while(argc-->=2&&nargc<10)
{
pstrcpy(infile[nargc],argv[nargc+1],LENFNAME);
nargc++;
}


cmenu_s(menustr,&outmain_f,infile,&nargc,&intfg,base,title);


box= avecPchar(mem);
boxname= amatchar(mem,8);
boxlen= aveclong(mem);
boxwid= avecreal(mem);

/*:8*//*9:*/
#line 211 "pscomb.w"

if(gl.font.ufac>0)gl.font.fac= gl.font.ufac;
gl.page.charsc= (0.250/gl.page.wide)*(gl.font.fac/7.1);
gl.page.lineht= 1000*gl.page.charsc;
gl.adpage.charsc= (0.250/gl.adpage.wide)*(gl.font.fac/7.1);
gl.adpage.lineht= gl.adpage.lineht= 1000*gl.adpage.charsc;



while(nargc-->0)
{
pstrcpy(inmain_f.fname,infile[nfile-1],LENFNAME);

ignflag= ON;
boxflag= OFF;


openf(&inmain_f,__FILE__,__LINE__,ON);
pstrcpy(buffer,getbuf(&inmain_f,"\n"),LENSTR2);
if(strstr(buffer,"%!PS-Adobe")==NULL)
{
derror(2);
rtn= putchar('\n');
assert(rtn!=EOF);
dlay();
continue;
}
pstrcpy(buffer,getbuf(&inmain_f,"\n"),LENSTR2);
if((strstr(buffer,"psimpoll")!=NULL)&&atof(buffer+20)<2.19)
{
derror(0);
rtn= putchar('\n');
assert(rtn!=EOF);
dlay();
continue;
}

startfile[nfile-1]= nbox+1;
rtn= printf("File %d ",nfile++);
assert(rtn>0);

for(;;)
{
pstrcpy(buffer,getbuf(&inmain_f,"\n"),LENSTR2);
if(buffer[0]=='%')
{
if(buffer[1]=='e')
{
boxflag= OFF;
ignflag= ON;
}
else if(buffer[1]=='i')
{
boxflag= OFF;
ignflag= ON;
}
else if(buffer[1]=='j')
{
boxflag= ON;
ignflag= OFF;
continue;
}
else if(buffer[1]=='n')
{
boxflag= ON;
nbox++;
if(nbox!=0)
{
if(box[nbox-1]!=NULL)
{
boxlen[nbox-1]= pstrlen(box[nbox-1])+1;
box[nbox-1]= rvecchar(box[nbox-1],boxlen[nbox-1]);
}
if(nbox==mem)
{
box= rvecPchar(box,mem+25);
for(i= mem;i<mem+25;i++)box[i]= NULL;
boxname= rmatchar(boxname,mem,mem+25,8);
boxwid= rvecreal(boxwid,mem+25);
boxlen= rveclong(boxlen,mem+25);
mem+= 25;
}

}

if(strstr(buffer,"SedC")!=NULL)gl.flag[TS]= ON;
rtn= printf("%s ",buffer+3);
assert(rtn>0);
rtn= fprintf(gl.logf.fp,"Box %d: reading %s\n",nbox,buffer+3);
assert(rtn>0);
if(box[nbox]==NULL)
{
boxlen[nbox]= 8000;
box[nbox]= avecchar(boxlen[nbox]);
}
if(sprintf(name,"%-6s",buffer+3)>10)PPERROR(24);
pstrcpy(boxname[nbox],name,8);
boxwid[nbox]= 0;
}
else if(buffer[1]=='s')
{
boxflag= OFF;
ignflag= OFF;
continue;
}
else if(buffer[1]=='t')
{
if(boxflag==ON)boxwid[nbox]+= atof(buffer+3);
}

}

if(ignflag==OFF)
{
(void)strcat(buffer,"\n");
if(pstrlen(box[nbox])+pstrlen(buffer)>=boxlen[nbox])
{
if(boxlen[nbox]>63000L)derror(16);
boxlen[nbox]+= 8000;
box[nbox]= rvecchar(box[nbox],boxlen[nbox]);
}

(void)strcat(box[nbox],buffer);

}

if(strstr(buffer,"EOF")!=NULL)break;
if(feof(inmain_f.fp)!=0)derror(14);

}

nbox++;
if(nbox!=0)
{
box[nbox-1]= rvecchar(box[nbox-1],pstrlen(box[nbox-1])+1);
boxlen[nbox-1]= pstrlen(box[nbox-1])+1;
}
rtn= putchar('\n');
assert(rtn!=EOF);


closef(&inmain_f,__FILE__,__LINE__);

nbox--;

}

if(nbox>237)intfg= OFF;

if(nbox>=0)
{
nbox++;
openf(&outmain_f,__FILE__,__LINE__,ON);
psinit(outmain_f,title,asize);
psnpage1(&newpge,&ipge);
PSPEN(10.0);
PSCOMM("s");


(void)sprintf(scline_f[2],"%d boxes",nbox);

if(intfg==OFF)
{
rtn= puts("Writing to output file");
assert(rtn!=EOF);
}
else
{


cls(scline_f,3,23);
nchar= 6;
if(nbox>110)nchar= 3;
if(nbox>152)nchar= 0;
nlbox= 79/(nchar+5);

k= 0;
nrow= 3;
nfile= 1;
while(k<nbox)
{

(void)sprintf(buffer," %3d ",k);
(void)strcat(scline_f[nrow],buffer);

if(k==startfile[nfile-1])
{
(void)sprintf(buffer,"%-2d",nfile++);
for(n= 0;n<2;n++)scline_f[nrow][n]= buffer[n];
}



(void)strncpy(buffer,boxname[k],nchar);
buffer[nchar]= '\0';


(void)strcat(scline_f[nrow],buffer);


if(pstrlen(scline_f[nrow])>=70)nrow++;


k++;

}

pstrcpy(scline_f[nrow+= 2],"Enter 'Q', or 'N': "
"see documentation for details",SCRWID);
npage= nrow+2;
nrow+= 3;

}






PSCOMM("i");

PSPEN(20.0);

pstext(outmain_f.fp,6,0.01,0,title,"F1",90);

PSPEN(10.0);
PSCOMM("j");


PSCOMM("i");
pstext(outmain_f.fp,6,(gl.page.prop+0.25),0,base,"F2",90);
PSCOMM("j");

while((!intfg&&ibox<nbox)||intfg)
{
if(intfg)
{


(void)sprintf(scline_f[npage],
"Taxa plotted so far: %34.2f pages plotted",
(ipge-1)+(ylo-gl.page.xmg)/gl.page.wide);
psc(scline_f);

fflush(stdin);
if(rkey[0]!='\0'&&strchr(rkey,'-')!=NULL)
{
pstrcpy(buffer_f,strchr(rkey,'-'),LENSTR2);
ilbox= atoi(buffer_f+1);
if(ibox>ilbox)
{
rkey[0]= '\0';
ilbox= 0;
}
}
if(strchr(rkey,'-')==NULL)
{
pstrcpy(rkey,getbuf(&Stdin,"\n"),10);
}

switch(rkey[0])
{
case'Q':case'q':intfg= OFF;break;
case'N':case'n':

psnpage1(&newpge,&ipge);
PSPEN(10.0);
PSCOMM("s");
ylo= gl.page.xmg;
break;
default:


if(isdigit(rkey[0])==0)continue;

if(ilbox==0)ibox= atoi(rkey);
if(ibox>nbox-1)continue;
break;

}

if(ucase(rkey[0])=='Q')
{
ibox= nbox;
continue;
}

else if(ucase(rkey[0])=='N')continue;

else
{

(void)sprintf(buffer," %d",ibox);


(void)strcat(scline_f[nrow],buffer);
scline_f[3+(ibox/nlbox)][4+(ibox%nlbox)*(5+nchar)]= '-';


if(pstrlen(scline_f[nrow])>=70)nrow++;

}

}

else
{
rtn= printf("%s ",boxname[ibox]);
assert(rtn>0);
}

if(ylo+boxwid[ibox]>gl.page.wide+gl.page.xmg)
{
psnpage1(&newpge,&ipge);
PSPEN(10.0);
PSCOMM("s");
ylo= gl.page.xmg;
}

rtn= fputs(box[ibox],outmain_f.fp);
assert(rtn!=EOF);
rtn= fprintf(gl.logf.fp,"Printing box %d\n",ibox);
assert(rtn>0);
ylo+= boxwid[ibox];

ibox++;

}

if(intfg==OFF)
{
rtn= putchar('\n');
assert(rtn!=EOF);
}

gl.page.ylo= ylo/gl.page.wide;


psclose1(ipge);


closef(&outmain_f,__FILE__,__LINE__);

fvec(boxwid);
fmatchar(boxname,mem);
for(i= 0;i<mem;i++)fvec(box[i]);
fvec(box);
fvec(boxlen);

}

else
{
rtn= puts("No boxes found in input files\nProgram ending");
assert(rtn!=EOF);
}

fmatchar(sclineb_f,SCRHT);
fmatchar(scline_f,SCRHT);
fmatchar(infile,10);

return(0);
}

/*:9*//*11:*/
#line 581 "pscomb.w"

static void cmenu_s
(
const char*const menustr[18],
file_t*outmain_f,
char**infile,
int*nargc,
flag_t*intfg,
char*base,
char*title
)

{
char buffer[5]= "";
letter_t s= 0;

do
{
sprintf(buffer,"%.1f",gl.font.ufac);

getfont();

pstrcpy(scline_f[MENULINE],menustr[4],SCRWID);
pstrcpy(scline_f[MENULINE+3],menustr[8],SCRWID);
pstrcpy(scline_f[MENULINE+5],menustr[16],SCRWID);
pstrcpy(scline_f[MENULINE+6],menustr[17],SCRWID);

(void)sprintf(scline_f[MENULINE+1],sfmt_f,menustr[5],gl.font.rom);
(void)sprintf(scline_f[MENULINE+2],"%s(%.1f)%21s[%s]",menustr[6],
gl.font.fac,"",gl.font.ufac>0?buffer:"");
(void)sprintf(scline_f[MENULINE+4],sfmt_f,menustr[10],
prnfg(*intfg));
psc(scline_f);

switch(s= ucase(getkey("EFGIKUX")))
{
case'E':
cmenue_s(menustr[4],&(*outmain_f),infile,&(*nargc));
break;
case'F':
menuf(menustr[5]);
break;
case'G':
menug(menustr[6]);
break;
case'I':
cmenui_s(menustr[8],base,title);
break;
case'K':
toggle(&(*intfg));
break;
case'U':
menuu(menustr[16]);
break;
case'X':
break;

}

}while(s!='X');

return;
}

/*:11*//*13:*/
#line 650 "pscomb.w"

static void cmenue_s
(
const char*const menustr,
file_t*outmain_f,
char**infile,
int*nargc
)

{
const char*const s= 
"Enter new filename (including drive and path) <Enter> ";
const char*const text[]= 
{
"Main PostScript output file",
"Input file(s)"
};

loop_t i= 0;
loop_t n= 0;

cls(sclineb_f,MENULINE,23);

while(n!='9')
{
pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
(void)sprintf(sclineb_f[MENULINE+1],"1 %-50s[%s]",text[0],
outmain_f->fname);
(void)sprintf(sclineb_f[MENULINE+2],"2 %-50s",text[1]);
pstrcpy(sclineb_f[MENULINE+3],quitline_f,SCRWID);
psc(sclineb_f);
switch(n= getkey("129"))
{
case'1':
pstrcpy(sclineb_f[MENULINE+5],s,SCRWID);
psc(sclineb_f);
pstrcpy(outmain_f->fname,getstr(LENFNAME),LENFNAME);
break;
case'2':
(void)sprintf(sclineb_f[MENULINE+5],"Current input files:");
for(i= 0;i<(*nargc);i++)
{
pstrcpy(sclineb_f[MENULINE+7+i],infile[i],SCRWID);
}
pstrcpy(sclineb_f[MENULINE+7+(*nargc)+2],s,SCRWID);
psc(sclineb_f);

pstrcpy(infile[(*nargc)++],getstr(LENFNAME),LENFNAME);
break;
case'9':break;
default:PPERROR(9);

}

cls(sclineb_f,MENULINE+5,23);

}

return;
}

/*:13*//*15:*/
#line 715 "pscomb.w"

static void cmenui_s
(
const char*const menustr,
char*base,
char*title
)

{
char buffer[LENSTR]= "";
char*pstr[7];
static char text[7][40]= 
{
"Title ",
"Label for base of diagram ",
"",
"",
"",
"",
""
};
loop_t n= 0;
loop_t k= 0;
int nlab= 2;

pstr[0]= title;
pstr[1]= base;

cls(sclineb_f,MENULINE,23);

for(;;)
{
pstrcpy(sclineb_f[MENULINE],menustr,SCRWID);
pstrcpy(sclineb_f[MENULINE+nlab+1],quitline_f,SCRWID);
for(k= 0;k<nlab;k++)
{
if(n==0||n==k+1)
{
*text[k]= (char)ucase(text[k][0]);
pstrcpy(buffer,pstr[k],25);
(void)sprintf(sclineb_f[MENULINE+k+1],"%d %-50s[%s]",k+1,
text[k],buffer);
}

}

psc(sclineb_f);

n= GETINT("12345679");
if(n>nlab)return;
else
{
*text[n-1]= (char)lcase(text[n-1][0]);
(void)sprintf(sclineb_f[MENULINE+nlab+3],"Enter %s <Enter>",
text[n-1]);
if(pstrlen(pstr[n-1])>25)
{
pstrcpy(sclineb_f[MENULINE+nlab+4],pstr[n-1],SCRWID);
}
psc(sclineb_f);
pstrcpy(pstr[n-1],getstr(LENSTR),LENSTR);
*sclineb_f[MENULINE+nlab+3]= '\0';
*sclineb_f[MENULINE+nlab+4]= '\0';
}

}


}/*:15*/
