/*6:*/
#line 6 "pphead.w"

#if 0==1
#define NDEBUG
#endif

#include <assert.h>

/*:6*//*7:*/
#line 14 "pphead.w"

#define DOUBLE

#define STDC 0

#ifdef __STDC__
#  if __STDC__ == 1
#    undef STDC
#    define STDC 1
#  endif
#endif

/*:7*//*9:*/
#line 31 "pphead.w"

#define GENAVEC(var_t)\
var_t *avec##var_t \
(\
long n \
)

/*:9*//*10:*/
#line 39 "pphead.w"

#define GENRVEC(var_t)\
var_t *rvec##var_t \
(\
var_t *v,\
int n \
)

/*:10*//*11:*/
#line 48 "pphead.w"

#define GENAMAT(var_t)\
var_t **amat##var_t \
(\
int nr,\
int nc \
)

/*:11*//*12:*/
#line 57 "pphead.w"

#define GENFMAT(var_t)\
void fmat##var_t \
(\
var_t **m,\
int nr \
)

/*:12*//*13:*/
#line 66 "pphead.w"

#define GENRMAT(var_t)\
var_t **rmat##var_t \
(\
var_t **m,\
int nr1,\
int nr2,\
int nc \
)

/*:13*//*14:*/
#line 77 "pphead.w"

#ifndef FLT_MAX
#  define FLT_MAX 1e37F
#endif

#ifndef FLT_MIN
#  define FLT_MIN 1e-37F
#endif

/*:14*//*15:*/
#line 87 "pphead.w"

#ifdef DOUBLE
#  define HUGE_EXP DBL_MAX_10_EXP
#else
#  define HUGE_EXP FLT_MAX_10_EXP
#endif

/*:15*//*16:*/
#line 95 "pphead.w"

#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#define SIGN(a, b)  ((b) > 0.0 ? fabs(a) : -fabs(a))
#define SQUARE(a) ((a) * (a))


/*:16*//*17:*/
#line 103 "pphead.w"

#define LOG2 0.69314718055994530942
#ifndef PI
#define PI 3.14159265358979323846
#endif
#define ROOT2 1.414213562373095


/*:17*//*18:*/
#line 112 "pphead.w"

#define A3HT 42000.0F 
#define A3WID 29700.0F 
#define A4HT 29700.0F 
#define A4WID 21000.0F 
#define LETTHT 27940.0F 
#define LETTWID 21590.0F 
#define LEGHT 35560.0F 
#define LEGWID 21590.0F 
#define ANG 90 
#define EXTRATAXN 10 
#define HMMPI 2540.0F 
#define LENFNAME FILENAME_MAX 
#define LENSTR 80 
#define LENSTR2 160 
#define LENSTR3 240 
#define LENTAXN 40 
#define MARKLEN 0.01F 
#define MAXSUM 10 
#define MENULINE 5 
#define NSUM 10 
#define PTSPI 72.0F 
#define SCRHT 25 
#define SCRWID 80 
#define TSLABLEN 4 
#define TSVALN 4 
#define XLABLEN 20 
#define ADFACT 5.0 

/*:18*//*19:*/
#line 142 "pphead.w"

#define CYAN 0
#define MAGENTA 1
#define YELLOW 2
#define BLACK 3

/*:19*//*20:*/
#line 149 "pphead.w"

#define DIAGOFF 0.16F 
#define LAB1OFF 0.125F 
#define LAB2OFF 0.145F 
#define NAMEOFF 0.14F 
#define TITLOFF 0.01F 

/*:20*//*21:*/
#line 157 "pphead.w"

#define ANNOOFF 0.04F 
#define FOOTOFF 0.09F 
#define LABLOFF 0.07F 
#define LINEOFF 0.02F 

/*:21*//*22:*/
#line 164 "pphead.w"

#define BIGFONT 1.728F 
#define SMALLFONT 0.694F 

/*:22*//*23:*/
#line 169 "pphead.w"

#define ZONE 0 
#define C14 1 
#define TS 2 
#define AD 3 
#define CFG 4 
#define LOGF 5 

/*:23*//*24:*/
#line 178 "pphead.w"

#define CLEARIN while (getchar() != '\n')

#define PPERROR(i)\
  do \
  {\
    (void)fprintf(stderr, "\n%s %d", __FILE__, __LINE__);\
    lerror(i);\
  } while (0)

#define ATOFG(string) (atoi(string) == 0 ? OFF : ON)

#define GETINT(list) (int)(getkey(list) - '0')
#define GETFG (((int)getkey("01") - '1') == OFF ? OFF : ON)

#define TOLOGC(w) (void)fprintf(gl.logf.fp, #w " = '%c'\n", w)
#define TOLOGF(x) (void)fprintf(gl.logf.fp, #x " = %f\n", (x))
#define TOLOGI(y) (void)fprintf(gl.logf.fp, #y " = %d\n", (y))
#define TOLOGL(y) (void)fprintf(gl.logf.fp, #y " = %ld\n", (y))
#define TOLOGS1(z) (void)fprintf(gl.logf.fp, #z ": %s\n", z)
#define TOLOGS2(z1, z2) (void)fprintf(gl.logf.fp, #z1 ": %s\n", z2)


/*:24*//*25:*/
#line 204 "pphead.w"

#ifdef SCO_ODT_30
#undef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC 1000000
#ifdef DBM
#include "malloc.h"
#endif
#endif

/*:25*//*26:*/
#line 214 "pphead.w"

#ifdef GCC
#  define STRERROR ((void)0)
#  define ATEXIT(func) ((void)0)
#  define EXIT(n)\
     ppend();\
     exit(n)
#else
#  define STRERROR \
     if (errno > 0)\
     {\
       (void)fprintf(stderr, "SYSTEM: %s\n", strerror(errno));\
     }
#  define ATEXIT(func)\
     rtn =  atexit(func);\
     assert(rtn == 0)
#  define EXIT(n) exit(n)
#endif


#ifdef TESTCOMP 
#  define CHECKTIME \
    do \
    {\
      struct tm comptime;\
      if (strstr(gl.date, "Jan") != NULL) comptime.tm_mon =  0;\
      else if (strstr(gl.date, "Feb") != NULL) comptime.tm_mon =  1;\
      else if (strstr(gl.date, "Mar") != NULL) comptime.tm_mon =  2;\
      else if (strstr(gl.date, "Apr") != NULL) comptime.tm_mon =  3;\
      else if (strstr(gl.date, "May") != NULL) comptime.tm_mon =  4;\
      else if (strstr(gl.date, "Jun") != NULL) comptime.tm_mon =  5;\
      else if (strstr(gl.date, "Jul") != NULL) comptime.tm_mon =  6;\
      else if (strstr(gl.date, "Aug") != NULL) comptime.tm_mon =  7;\
      else if (strstr(gl.date, "Sep") != NULL) comptime.tm_mon =  8;\
      else if (strstr(gl.date, "Oct") != NULL) comptime.tm_mon =  9;\
      else if (strstr(gl.date, "Nov") != NULL) comptime.tm_mon =  10;\
      else if (strstr(gl.date, "Dec") != NULL) comptime.tm_mon =  11;\
      comptime.tm_year =  atoi(gl.date + 9);\
      comptime.tm_mday =  atoi(gl.date + 4);\
      comptime.tm_sec =  0;\
      comptime.tm_min =  0;\
      comptime.tm_hour =  0;\
      comptime.tm_sec =  0;\
      comptime.tm_isdst =  -1;\
      if (mktime(&comptime) > time((time_t *)NULL)) exit(EXIT_FAILURE);\
\
      comptime.tm_mon +=  TESTMON;\
      if (comptime.tm_mon > 11)\
      {\
        comptime.tm_year +=  1;\
        comptime.tm_mon -=  12;\
      }\
      if (mktime(&comptime) < time((time_t *)NULL)) exit(EXIT_FAILURE);\
    } while(0)
#else
#  define CHECKTIME ((void)0)
#endif

/*:26*/
