/*5:*/
#line 17 "ppfunc.w"

#include "psimpoll.h"
#include "ppglobal.h" 
#include "ppfunc1.h" 
#include "ppfunc2.h" 
#include "ppps.h" 
#include "ppscreen.h" 


/*:5*//*6:*/
#line 27 "ppfunc.w"

extern const char*opertext_f[9];
extern file_t outmain_f;

/*:6*//*7:*/
#line 32 "ppfunc.w"

static char buffer_f[LENSTR2];

/*:7*//*9:*/
#line 44 "ppfunc.w"

void plottaxa
(
data_t data,
samp_t lev,
file_t script,
int*ipge,
flag_t*newpge,
int*nsum,
rc14_t c14,
sed_t sed,
caption_t head,
int raresam,
xaxis_t xsamp,
xaxis_t xtime,
char*title,
ts_t ts,
zone_t zon,
int nci,
flag_t*intfg,
flag_t agetimx,
file_t*stat,
frame_t coll,
char sunit[12][LENSTR/2]
)

{
/*:9*//*10:*/
#line 72 "ppfunc.w"

static char rkey[10]= "";

static char text[LENSTR2]= "";

file_t Stdin= 
{
"stdin",NULL,OPEN,""
};

frame_t ind= 
{
OFF,OFF,OFF,0.5,OFF,OFF,OFF,OFF,OFF,OFF,OUTL,0,PLAIN,1,1,
0,0,45,0,SCRWRITE,OFF,0,0,0,0,0,0
};

flag_t endline= OFF;
flag_t igap= OFF;

real a= 0;
real allj= 0;
real alllev= 0;
real endfn= 0;
real wtaveopt= 0;
real wtavetol= 0;
real xlev= 0;
real xlevold= 0;
real yplot= 0;

real yplotold[8];


int itax= 0;
int iltax= 0;
int itaxty= 0;
int nchar= 0;
int nltax= 0;


int npage= 0;
int nrow= 0;
int nsamp= 0;
int nsmooth= 3;

loop_t j= 0;
loop_t k= 0;
loop_t l= 0;
loop_t n= 0;


real*sampval= NULL;
real*dataval= NULL;

real**yplotex= NULL;

/*:10*//*11:*/
#line 128 "ppfunc.w"

alllev= lev.max-lev.min;
Stdin.fp= stdin;

buffer_f[0]= '\0';


if(coll.indscale==OFF)
{


if(gl.code.dat=='%')coll.max= 100;
else datasc_x(coll.max-coll.min,&coll);
}

rtn= fputs("Contents of struct Coll coll (c):\n",gl.logf.fp);
assert(rtn!=EOF);
logcoll_x(coll);

/*:11*//*12:*/
#line 148 "ppfunc.w"

yplotex= amatreal(10,data.nsam);

/*:12*//*13:*/
#line 152 "ppfunc.w"

if(*intfg==OFF)
{
rtn= puts("Writing to output file");
assert(rtn!=EOF);
}
else
{
fillscreen_x(data.taxname,data.ntax,&nchar,&nltax,&npage,&nrow);

script.mode[0]= (char)(coll.script==SCRREAD?'r':'w');
openf(&script,__FILE__,__LINE__,OFF);
if(coll.script==SCRREAD&&script.st==CLOSED)derror(19);
else if(coll.script==SCRWRITE&&script.st==CLOSED)PPERROR(8);

}

/*:13*//*14:*/
#line 170 "ppfunc.w"

while((*intfg==OFF&&itax<data.ntax)||*intfg==ON)
{

/*19:*/
#line 213 "ppfunc.w"

real fdummy1= 0;
real fdummy2= 0;

/*:19*/
#line 174 "ppfunc.w"

/*20:*/
#line 218 "ppfunc.w"

rtn= fputc('\n',gl.logf.fp);
assert(rtn!=EOF);


if(ind.indspl==ON||ind.ix10==ON)endline= ON;
else endline= OFF;




ind= coll;
ind.max= ind.min= 0;
endfn= 0;

/*:20*/
#line 175 "ppfunc.w"

/*21:*/
#line 235 "ppfunc.w"

if(*intfg==ON)
{
fdummy1= gl.page.ylo+gl.page.zon;
fdummy2= gl.page.ylo+(2.5F*gl.page.sep);
if(npage<SCRHT)
{
rtn= sprintf(scline_f[npage],
"Taxa plotted so far: %34.2f pages plotted",
((real)(*ipge)-1.0)+MAX(fdummy1,fdummy2));
assert(rtn>0&&rtn<SCRWID);
}
psc(scline_f);


if(rkey[0]!='\0'&&strchr(rkey,'-')!=NULL)
{
pstrcpy(buffer_f,strchr(rkey,'-'),LENSTR2);
iltax= atoi(buffer_f+1);
if(itax>iltax)
{
rkey[0]= '\0';
iltax= 0;
}
}
if(strchr(rkey,'-')==NULL)
{
pstrcpy(rkey,getbuf(coll.script==SCRREAD?&script:&Stdin,"\n"),10);
rkey[0]= (char)ucase(rkey[0]);

if(coll.script==SCRREAD)
{
rtn= putchar('\n');
assert(rtn!=EOF);
}


if(coll.script==SCRREAD&&feof(script.fp)!=0)
{
derror(24);
pstrcpy(rkey,"Q",10);
}


if(coll.script==SCRWRITE)
{
rtn= fprintf(script.fp,"%s\n",rkey);
assert(rtn>0);
}

}

switch(rkey[0])
{
case'Q':
*intfg= OFF;
itax= data.ntax;
break;
case'N':




if(endline==ON)
{
PSCOMM("n Line");
pslineto(1,DIAGOFF+gl.page.prop,0,-gl.page.prop,0);
}


if(gl.flag[ZONE]==ON)pszoncol_x(head.zone,zon,coll,lev);
else maindepax_x(2,OFF,0,head,lev,xsamp,coll);


psnpage1(&(*newpge),&(*ipge));
PSPEN(10.0*coll.penwid);
PSCOMM("s");

break;

default:


if(isdigit(rkey[0])==0)continue;

if(iltax==0)itax= atoi(rkey);
if(itax>data.ntax-1)
{
itax= data.ntax-1;
continue;
}



plotdef_x(rkey,&script,&(*stat),coll,&ind,&nsmooth,&data,
itax);

break;

}

if(rkey[0]=='Q'||rkey[0]=='N')continue;
else
{
int idummy1= 0;
int idummy2= 0;

rtn= sprintf(buffer_f," %d",itax);
assert(rtn>0&&rtn<LENSTR2);


if(nrow<SCRHT-1)(void)strncat(scline_f[nrow],buffer_f,SCRWID);
idummy1= 3+itax/nltax;
assert(idummy1>=0&&idummy1<SCRHT);
idummy2= 4+(itax%nltax)*(5+nchar);
assert(idummy2>=0&&idummy2<SCRWID);
scline_f[idummy1][idummy2]= '-';


if(nrow<SCRHT-1)
{
if(pstrlen(scline_f[nrow])>=SCRWID-10)nrow++;
}

}

}

/*22:*/
#line 405 "ppfunc.w"

TOLOGI(itax);
rtn= fprintf(gl.logf.fp,"Plotting %s\n",data.taxname[itax]);
assert(rtn>0);




itaxty= data.taxname[itax][0];


if(itaxty=='\\')ind.exchar= ON;


else if(itaxty=='-')
{
itax++;
rtn= fputs(" - excluded taxon\n",gl.logf.fp);
assert(rtn!=EOF);
continue;
}

if(gl.code.dat=='B'&&itaxty=='&')itaxty= '%';

if(itaxty>31)TOLOGC(itaxty);
else TOLOGI(itaxty);


plottype_x(itaxty,&ind);


obtpmax_x(data,&ind,itax,itaxty,yplotex,nsum,sed,nci,&(*stat));

allj= ind.max-ind.min;




if(ind.indscale==OFF&&coll.indscale==OFF&&
allj>2*(coll.max-coll.min))
{
ind.indscale= ON;
}


if(ind.indscale==ON)datasc_x(allj,&ind);

fdummy1= ind.max*ind.scale*ind.finscale;
ind.max= MAX(fdummy1,5);
ind.min*= (ind.scale*ind.finscale);
allj= ind.max-ind.min;
ind.datamax*= (ind.scale*ind.finscale);
ind.datamin*= (ind.scale*ind.finscale);
ind.median*= (ind.scale*ind.finscale);
ind.lq*= (ind.scale*ind.finscale);
ind.uq*= (ind.scale*ind.finscale);


if(gl.code.dat!='%')ind.lval*= ind.scale*ind.finscale;

rtn= fputs("Contents of struct Coll ind (c):\n",gl.logf.fp);
assert(rtn!=EOF);
logcoll_x(ind);

/*:22*/
#line 363 "ppfunc.w"


/*:21*/
#line 176 "ppfunc.w"

/*23:*/
#line 470 "ppfunc.w"

if(gl.page.ylo+gl.page.sep+gl.page.minpl*allj>
1-4*gl.page.sep-gl.page.ad-gl.page.zon)
{



if(endline==ON)
{
PSCOMM("n Line");
pslineto(1,DIAGOFF+gl.page.prop,0,-gl.page.prop,0);
}


if(gl.flag[ZONE]==ON)pszoncol_x(head.zone,zon,coll,lev);
else maindepax_x(2,OFF,0,head,lev,xsamp,coll);


psnpage1(&(*newpge),&(*ipge));
PSPEN(10.0*coll.penwid);
PSCOMM("s");
}

/*:23*/
#line 177 "ppfunc.w"

/*24:*/
#line 494 "ppfunc.w"

if(*newpge==ON)
{

PSCOMM("i");

PSPEN(20.0*coll.penwid);
pscolour(outmain_f.fp,coll.coltit);

pstext(outmain_f.fp,6,TITLOFF,0,title,"F1",ANG);

pscolour(outmain_f.fp,gl.palette.fore);
PSCOMM("j");


maindepax_x(1,OFF,0,head,lev,xsamp,coll);
if(agetimx==ON)maindepax_x(1,agetimx,coll.rot,head,lev,xtime,coll);

PSPEN(10.0*coll.penwid);


if(gl.flag[TS]==ON&&(gl.code.yax=='D'||gl.code.yax=='M'))
{
pssedcol_x(data,ts,head.sed,coll,lev);
}


if(coll.c14scale==ON&&c14.num>0)
{
psc14col_x(c14,head.c14,coll,lev);
}


pstrcpy(buffer_f,getfoot_x(coll.scale,head.base,sunit),LENSTR2-1);
PSCOMM("i");
pstext(outmain_f.fp,6,DIAGOFF+gl.page.prop+FOOTOFF,0,buffer_f,"F2",ANG);
PSCOMM("j");


*newpge= OFF;
if(*intfg==OFF)
{
rtn= printf("\nPage %d ",*ipge);
assert(rtn>0);
}

}

/*:24*/
#line 178 "ppfunc.w"

/*25:*/
#line 543 "ppfunc.w"

pstrcpy(text,data.taxname[itax],6);
rtn= sprintf(buffer_f,"n %s",text);
assert(rtn>0&&rtn<LENSTR2);
PSCOMM(buffer_f);

if(*intfg==OFF)
{
rtn= printf("%s: ",data.taxname[itax]);
assert(rtn>0);
}



pstran(0,-ind.min*gl.page.minpl);


for(k= 0;k<zon.num;k++)
{
real azonmax= 0;
real azonmin= 0;
real xhi= 0;
real xlo= 0;



azonmin= zon.dep[k];
azonmax= zon.dep[k+1];
if(azonmin<=lev.max&&azonmax>=lev.min)
{
azonmin= MAX(azonmin,lev.min);
azonmax= MIN(azonmax,lev.max);
xhi= xlo= DIAGOFF;
xhi+= ((azonmin-lev.min)/(lev.ex-lev.min))*gl.page.prop;
xlo+= ((azonmax-lev.min)/(lev.ex-lev.min))*gl.page.prop;


if(gl.colzone==ON)
{
pscolour(outmain_f.fp,gl.palette.zoneid[k]);
psbox2(outmain_f.fp,2,xlo,xhi,ind.min*gl.page.minpl,
ind.max*gl.page.minpl+gl.page.sep);
pscolour(outmain_f.fp,gl.palette.fore);
}

}

}


if(ind.curve==HIST&&coll.curve!=HIST)
{
ind.hist= gl.page.prop*ind.hist/(lev.ex-lev.min);
ind.hist/= 2;
}

rtn= fputs("Labelling x-axis\n",gl.logf.fp);
assert(rtn!=EOF);

PSPEN2(outmain_f.fp,ind.penwid);


if(ind.curve!=NUMBER)
{
xscale_x(coll,&ind,itaxty,raresam,data.exlabel[itax],&allj,&endfn,
sunit);
}
TOLOGF(endfn);

pscolour(outmain_f.fp,ind.colpl);


if(ind.curve==NUMBER&&gl.flag[ZONE]==ON)
{
gl.page.ysumlo[gl.page.nysum]= gl.page.ylo;
gl.page.ysumhi[gl.page.nysum]= gl.page.ylo+(ind.max*gl.page.minpl)+
gl.page.sep;
if(gl.page.nysum<(NSUM-1))gl.page.nysum++;
}






rtn= fputs("Building plot\n",gl.logf.fp);
assert(rtn!=EOF);
yplotold[0]= -1;
if(ind.curve==SUMMARY)
{
for(l= 1;l<=data.summary.n;l++)yplotold[l]= -1;
}

if(ind.ix10==ON)
{
PSOPER(4);
psclip(DIAGOFF,0,gl.page.prop,ind.max*gl.page.minpl+gl.page.sep);
}

xlevold= -1;


for(j= 0;j<data.nsam;j++)
{
real blev= 0;
if(data.levfg[j]==OFF)continue;
yplot= (real)data.dat[itax][j]*ind.scale*ind.finscale;
if(ind.curve==CONFIN)l= 1;
else if(ind.curve==SUMMARY)l= data.summary.n-2;
else l= -1;

for(k= 0;k<=l;k++)yplotex[k][j]*= (ind.scale*ind.finscale);

if(itaxty!='=')blev= (real)data.alev[j];
else
{
if(data.dat[itax][j]<(float)gl.neglev||data.levfg[j]==OFF)
{
blev= -FLT_MAX;
}
else
{
n= 1;
while(blev<=FLT_MIN&&blev>=-FLT_MIN)
{
if(data.levfg[j+n]==OFF)
{
if(++n+j==data.nsam)blev= -FLT_MAX;
}
else blev= (real)(data.alev[j]+data.alev[j+n])/2;

}

}

}


if(blev<lev.min||blev>lev.max||
yplot<(gl.neglev*ind.scale*ind.finscale))
{
if(coll.join==OFF)xlevold= -1;
}
else
{

xlev= DIAGOFF+(((blev-lev.min)/(lev.ex-lev.min))*
gl.page.prop);


if(ind.bull==ON&&yplot<ind.lval&&yplot>FLT_MIN)
{
pstext(outmain_f.fp,8,xlev+gl.page.lineht/2,2*gl.page.minpl,"\\267",
"F4",ANG);
}

switch(ind.curve)
{
case CONFIN:
confcurve_x(xlev,yplotex,j,yplot,xlevold,yplotold[0],ind);
break;
case HIST:
histcurve_x(xlev,data.histwid[j],yplot,lev.ex-lev.min,&ind,
coll);
break;
case NUMBER:
numbcurve_x(xlev,ind,data.dat[itax][j],&igap,data.nsam,
coll.sum2col);
break;
case SUMMARY:
summcurve_x(xlev,yplotex,j,yplot,xlevold,yplotold,
data.summary,ind);
break;
case PLAIN:
plaicurve_x(xlev,yplot,xlevold,yplotold[0],ind);
break;

}

if(xlevold>=0&&ind.ix10==ON)
{
fdummy1= gl.page.minpl*10;
psgoto('m',xlev,yplot*fdummy1);
psgoto('l',xlevold,yplotold[0]*fdummy1);
PSOPER(3);
}



if(ind.bars==OFF)
{
xlevold= xlev;
yplotold[0]= yplot;

if(ind.curve==SUMMARY)
{
for(l= 1;l<data.summary.n;l++)
{
yplotold[l]= yplotex[l-1][j];
}

}

}

}

}


pscolour(outmain_f.fp,gl.palette.fore);
PSPEN2(outmain_f.fp,coll.penwid);

if(ind.curve==SUMMARY)
{
pslineto(0,DIAGOFF,0,0,allj*gl.page.minpl);
fdummy1= DIAGOFF+((alllev/(lev.ex-lev.min))*gl.page.prop);
psgoto('l',fdummy1,allj*gl.page.minpl);
psgoto('l',fdummy1,0);
PSOPER(3);
}


if(ind.ix10==ON)PSOPER(5);

if(gl.tufte==ON)
{
nsamp= 0;
if(sampval==NULL)sampval= avecreal(data.nsam);
if(dataval==NULL)dataval= avecreal(data.nsam);

for(j= 0;j<data.nsam;j++)
{
if(data.levfg[j]==ON&&data.dat[itax][j]>(float)gl.neglev)
{
sampval[nsamp]= (real)data.alev[j];
dataval[nsamp]= (real)data.dat[itax][j];
nsamp++;
}

}

wtave(sampval,dataval,nsamp,&fdummy1,&fdummy2,&wtaveopt,&wtavetol);

}

if(gl.tufte==OFF)
{

fdummy1= (real)(coll.curve==HIST?0:ind.hist);
fdummy2= (alllev/(lev.ex-lev.min)*gl.page.prop)+2*fdummy1;
pslineto(1,DIAGOFF-fdummy1,0,fdummy2,0);
}
else
{
real lowrange= 0;
real highrange= 0;

lowrange= MAX(lev.min,wtaveopt-wtavetol);
fdummy1= DIAGOFF+(((lowrange-lev.min)/(lev.ex-lev.min))*
gl.page.prop);
highrange= (wtaveopt-lowrange)+MIN(lev.max-wtaveopt,wtavetol);
fdummy2= (highrange/(lev.ex-lev.min))*gl.page.prop;
pslineto(1,fdummy1,0,fdummy2,0);

fdummy1= DIAGOFF+(((wtaveopt-lev.min)/(lev.ex-lev.min))*
gl.page.prop);
pslineto(1,fdummy1,0,0,-gl.page.sep/2);
}


pscolour(outmain_f.fp,gl.palette.fore);

rtn= fputs("Adding taxon name\n",gl.logf.fp);
assert(rtn!=EOF);



a= 0;
k= 0;

if(ind.curve!=SUMMARY)
{

if(ind.exchar==ON)data.taxname[itax]++;

pstext(outmain_f.fp,6,NAMEOFF,a,data.taxname[itax],"F2",ANG+ind.rot);
if(ind.exchar==ON)data.taxname[itax]--;
}
else
{
while(k<data.summary.n)
{


pstext(outmain_f.fp,6,NAMEOFF,a,data.summary.name[k],"F2",
ANG+ind.rot);
k++;

a+= ((95*gl.page.minpl)/((real)data.summary.n-1));

}

}

if(ind.indspl==ON)
{
int i= 0;
real*splits= NULL;

splits= avecreal(20);
dprint(&(*stat),"\nIndependent splitting for %s:\n",
data.taxname[itax]);
indsplit(itax,data,&(*stat),splits);
while(splits[i]<FLT_MAX)
{
xlev= DIAGOFF+((fabse(splits[i])-lev.min)/(lev.ex-lev.min))
*gl.page.prop;
if(splits[i]<0)PSDASH(50,50);
pslineto(1,xlev,0,0,ind.max*gl.page.minpl+gl.page.sep);
if(splits[i++]<0)PSNODASH;
}


if(splits[0]==FLT_MAX)ind.indspl= OFF;

fvec(splits);

}



pstran(0,gl.page.sep+ind.max*gl.page.minpl);


itax++;


pscolour(outmain_f.fp,gl.palette.fore);



rtn= fputs("Plot completed\n",gl.logf.fp);
assert(rtn!=EOF);
/*:25*/
#line 179 "ppfunc.w"


}

/*:14*//*15:*/
#line 184 "ppfunc.w"

if(script.st==OPEN)closef(&script,__FILE__,__LINE__);

fvec(dataval);
fvec(sampval);
fmatreal(yplotex,10);

/*:15*//*16:*/
#line 192 "ppfunc.w"


if(endline==ON)
{
PSCOMM("n Line");
pslineto(1,DIAGOFF+gl.page.prop,0,-gl.page.prop,0);
}

/*:16*//*17:*/
#line 201 "ppfunc.w"

if(gl.flag[ZONE]==ON)pszoncol_x(head.zone,zon,coll,lev);
else maindepax_x(2,OFF,0,head,lev,xsamp,coll);

/*:17*//*18:*/
#line 206 "ppfunc.w"

psclose1(*ipge);

return;
}

/*:18*/
