/*3:*/
#line 14 "ppfuncx2.w"

#include "psimpoll.h"
#include "ppglobal.h" 
#include "ppfunc1.h" 
#include "ppfunc2.h" 
#include "ppps.h" 
#include "ppscreen.h" 


/*:3*//*4:*/
#line 24 "ppfuncx2.w"

extern const char*opertext_f[9];
extern file_t outmain_f;

/*:4*//*5:*/
#line 29 "ppfuncx2.w"

static char buffer_f[LENSTR2];

/*:5*//*6:*/
#line 33 "ppfuncx2.w"

/*7:*/
#line 38 "ppfuncx2.w"

static char*getlabel_s(const int icode,const int magsc,const char*const sx,
real*const nleng,char sunit[12][LENSTR/2]);
/*:7*/
#line 34 "ppfuncx2.w"


/*:6*//*8:*/
#line 42 "ppfuncx2.w"

static char*getlabel_s
(
const int icode,
const int magsc,
const char*const sx,
real*const nleng,
char sunit[12][LENSTR/2]
)

{
int nl= 0;

char buffer[LENSTR]= "";
static char text[LENSTR2]= "";

text[0]= '\0';
*nleng= 0;

switch(magsc)
{

case-INT_MAX:
break;
case 0:
rtn= sprintf(buffer,"\\327 1 ");
assert(rtn>0&&rtn<LENSTR);
break;
case 1:
rtn= sprintf(buffer,"\\327 10 ");
assert(rtn>0&&rtn<LENSTR);
break;
default:
rtn= sprintf(buffer,"\\327 10{%d} ",magsc);
assert(rtn>0&&rtn<LENSTR);
break;
}
vstrcat(LENSTR2,text,buffer,(char*)NULL);
(*nleng)+= (3*strwid("0"));
(*nleng)+= strwid("+ ");


switch(icode)
{
case'+':
if(gl.code.dat=='A'||gl.code.dat=='B')nl= 1;
else if(gl.code.dat=='C'||gl.code.dat=='G')nl= 3;
break;
case'&':
nl= 4;
break;
case'%':
nl= 5;
break;
case'\'':
nl= 6;
break;
case'@':
nl= 7;
break;
case'=':
nl= 8;
break;
case':':
nl= 9;
break;
case'!':
nl= 11;
break;
}

if(nl==11)
{
rtn= sprintf(buffer,"E(T[%s])",sx);
assert(rtn>0&&rtn<LENSTR);
vstrcat(LENSTR2,text,buffer,(char*)NULL);
(*nleng)+= strwid(buffer);
}
else if(pstrlen(sx)>0)
{
(void)strcat(text,sx);
(*nleng)+= strwid(sx);
}
else if(nl>0)
{
(void)strcat(text,sunit[nl-1]);
(*nleng)+= strwid(sunit[nl-1]);
}

return(text);
}


/*:8*//*10:*/
#line 143 "ppfuncx2.w"

void plotdef_x
(
const char*const rkey,
file_t*const script,
file_t*const stat,
const frame_t coll,
frame_t*const ind,
int*const nsmooth,
data_t*const data,
const int itax
)

{
loop_t j= 0;
loop_t n= 0;

buffer_f[0]= '\0';

for(n= 0;n<pstrlen(rkey);n++)
{
real*realdat= NULL;
real*reallev= NULL;
switch(ucase(rkey[n]))
{
case'B':
ind->bull= ON;

ind->lval= (real)atof(rkey+n+1);
if(ind->lval<FLT_MIN)ind->lval= coll.lval;
break;
case'C':
if(rkey[n+1]=='?')
{
rtn= sprintf(scline_f[SCRHT-2],
"Current colour is '%s': enter new colour <Enter>",
findcolour(ind->colpl));
assert(rtn>0&&rtn<SCRWID);
psc(scline_f);
if(coll.script==SCRREAD)pstrcpy(buffer_f,getbuf(&(*script),"\n"),
LENSTR);
else if(coll.script==SCRWRITE)
{
pstrcpy(buffer_f,getstr(LENTAXN),LENTAXN);
}
ind->colpl= findcolourid(buffer_f);
printf("%ld %s\n",ind->colpl,buffer_f);
if(coll.script==SCRWRITE)
{
rtn= fprintf(script->fp,"%s\n",buffer_f);
assert(rtn>0);
}
}
else ind->colpl= atoi(rkey+n+1);
scline_f[SCRHT-2][0]= '\0';
break;
case'F':
ind->shade= coll.shade;
ind->style= FILL;
break;
case'D':
ind->ix10= OFF;
break;
case'E':
ind->ix10= ON;
break;
case'G':
ind->shade= (real)atof(rkey+n+1);
ind->shade= MIN((real)1,ind->shade);
ind->shade= MAX((real)0,ind->shade);
ind->style= FILL;
break;
case'H':
ind->curve= HIST;

ind->hist= (real)atof(rkey+n+1);
break;
case'O':
ind->style= OUTL;
break;
case'P':

ind->penwid= (real)atof(rkey+n+1);
break;
case'S':

*nsmooth= atoi(rkey+n+1);
if(*nsmooth%2==0)*nsmooth= 3;
if(*nsmooth==0)*nsmooth= 3;
realdat= avecreal(data->nsam);
reallev= avecreal(data->nsam);
for(j= 0;j<data->nsam;j++)
{
realdat[j]= (real)data->dat[itax][j];
reallev[j]= (real)data->alev[j];
}
smooth(realdat,reallev,data->nsam,*nsmooth);
for(j= 0;j<data->nsam;j++)
{
data->dat[itax][j]= (float)realdat[j];
data->alev[j]= (float)reallev[j];
}
fvec(realdat);
fvec(reallev);
rtn= fprintf(gl.logf.fp,"Taxon smoothed (%d point)\n",*nsmooth);
ind->curve= PLAIN;
assert(rtn>0);
if(stat->st==OPEN)
{
rtn= fprintf(stat->fp,"\nSmoothed data:\n%s ",
data->taxname[itax]);
assert(rtn>0);
for(j= 0;j<data->nsam;j++)
{
rtn= fprintf(stat->fp,"%.6f ",data->dat[itax][j]);
assert(rtn>0);
}
rtn= fputc('\n',stat->fp);
assert(rtn!=EOF);
}
break;
case'T':
if(coll.script==SCRREAD)pstrcpy(buffer_f,getbuf(&(*script),"\n"),
LENSTR);
else if(coll.script==SCRWRITE)
{
rtn= sprintf(scline_f[SCRHT-2],
"Current taxon name is '%s': enter new name <Enter>",
data->taxname[itax]);
assert(rtn>0&&rtn<SCRWID);
psc(scline_f);
pstrcpy(buffer_f,getstr(LENSTR),LENSTR);
rtn= fprintf(script->fp,"%s\n",buffer_f);
assert(rtn>0);
}
rtn= fprintf(gl.logf.fp,"Changing name from %s to %s\n",
data->taxname[itax],buffer_f);
assert(rtn>0);
if(pstrlen(buffer_f)+1>LENTAXN)
{
data->taxname[itax]= rvecchar(data->taxname[itax],
pstrlen(buffer_f)+1);
}
pstrcpy(data->taxname[itax],buffer_f,
MAX(LENTAXN,pstrlen(buffer_f)+1));
scline_f[SCRHT-2][0]= '\0';
break;

case'X':
ind->ulimit= ON;
break;

}

}

return;
}


/*:10*//*12:*/
#line 308 "ppfuncx2.w"

void plottype_x
(
const int itaxty,
frame_t*const ind
)

{
switch(itaxty)
{
case'!':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->ix10= OFF;
ind->style= OUTL;
ind->curve= CONFIN;
break;
case'#':
ind->exchar= ON;
ind->indscale= ON;
break;
case'%':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
break;
case'&':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
break;
case'\'':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
break;
case'*':
ind->bars= ON;
ind->bull= OFF;
ind->exchar= ON;
ind->hist= 0;
ind->indspl= OFF;
ind->ix10= OFF;
ind->curve= NUMBER;
break;
case'+':
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
break;
case':':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->ix10= OFF;
ind->curve= PLAIN;
break;
case'<':
ind->bull= OFF;
ind->ix10= OFF;
ind->curve= SUMMARY;
ind->indspl= OFF;
break;
case'=':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
ind->indspl= OFF;
break;
case'@':
ind->bull= OFF;
ind->exchar= ON;
ind->indscale= ON;
ind->curve= PLAIN;
break;

}

return;
}


/*:12*//*14:*/
#line 401 "ppfuncx2.w"

void psc14col_x
(
const rc14_t c14,
const char*const c14head,
const frame_t coll,
const samp_t lev
)

{
static char text[LENSTR]= "";

real fdummy1= 0;
real lens= 0;
real leng= 0;
real leng2= 0;
real rc14= 0;
real xlo= 0;
real xhi= 0;
real y1= 0;
real y2= 0;

loop_t m= 0;

buffer_f[0]= '\0';

PSCOMM("n C14C");


pstran(0,-gl.page.sep/2);


pscolour(outmain_f.fp,coll.col14c);


for(m= 0;m<c14.num;m++)
{
xhi= xlo= -1;
rc14= (real)atof(c14.age[m]);

switch(gl.code.yax)
{
case'D':case'M':

if(MAX(c14.dp1[m],c14.dp2[m])>=lev.min&&
MIN(c14.dp1[m],c14.dp2[m])<=lev.ex)
{


y1= y2= DIAGOFF;
y1+= ((c14.dp1[m]-lev.min)/(lev.ex-lev.min))*gl.page.prop;
y2+= ((c14.dp2[m]-lev.min)/(lev.ex-lev.min))*gl.page.prop;
xlo= MIN(y1,y2);
xhi= MAX(y1,y2);


if(isdigit(c14.sd[m][0])!=0)
{
pstrcpy(buffer_f,"\\261",LENSTR);
lens= strwid(buffer_f);
}
else
{
buffer_f[0]= '\0';
lens= 0;
}

text[0]= '\0';
vstrcat(LENSTR,text,c14.age[m],buffer_f,c14.sd[m],(char*)NULL);
leng2= strwid(c14.age[m])+lens+strwid(c14.sd[m]);
leng= MAX(leng,leng2);

}

break;

case'A':
if(c14.age[m][0]>=48&&c14.age[m][0]<=57)
{
if(rc14>=lev.min&&rc14<=lev.ex)
{
xlo= xhi= DIAGOFF+((rc14-lev.min)/(lev.ex-lev.min))*
gl.page.prop;
}

}
break;

default:PPERROR(9);

}

if(xhi>0&&xlo>0)
{

if(xlo==xhi)
{
pstext(outmain_f.fp,8,xhi+(gl.page.lineht/2),0.005F,"\\304","F4",ANG);
}

else psbox(2,xhi,xlo,0.01F,0);

fdummy1= (xlo+xhi)/2+gl.page.lineht/2;
pstext(outmain_f.fp,6,fdummy1,0.0125F,text,"F2",ANG);

}

}

gl.page.c14= 0.0125F+leng+strwid(" ");

pstext(outmain_f.fp,6,NAMEOFF,0,c14head,"F2",ANG+coll.rot);


pscolour(outmain_f.fp,gl.palette.fore);


pstran(0,gl.page.c14+(gl.page.sep/2));

return;
}


/*:14*//*16:*/
#line 530 "ppfuncx2.w"

void pssedcol_x
(
const data_t data,
ts_t ts,
const char*const sedhead,
const frame_t coll,
const samp_t lev
)

{
real boxwid= 0;
real bxht= 0;
real bxwid= 0;
real fdummy1= 0;
real xhi= 0;
real xlo= 0;

real lastdep= 0;

int itscal= 0;

int iv= 0;
int iy= 0;
int iyy= 0;
int n= 0;

loop_t l= 0;
loop_t m= 0;

char tssym[5]= "";

boxwid= (gl.page.ts-(gl.page.sep/2));

PSCOMM("n SedC");



pstran(0,-gl.page.sep/2);

PSPEN(5*coll.penwid);
pscolour(outmain_f.fp,coll.colts);


xhi= (lev.udata==OFF?DIAGOFF:DIAGOFF+
(((lev.origmin-lev.min)/(lev.ex-lev.min))*gl.page.prop));


pslineto(0,DIAGOFF+gl.page.prop,0,-gl.page.prop,0);
pslineto(boxwid,DIAGOFF+gl.page.prop,boxwid,-gl.page.prop,0);


pslineto(1,xhi,0,0,boxwid);


pstext(outmain_f.fp,6,NAMEOFF,0,sedhead,"F2",ANG+coll.rot);

PSOPER(4);

psclip(DIAGOFF,0,gl.page.prop,boxwid);

for(m= 0;m<ts.num;m++)
{

ts.dep[m]= MIN(lev.ex,ts.dep[m]);
lastdep= (m>0)?ts.dep[m-1]:0;

xlo= DIAGOFF+(((ts.dep[m]-lev.min)/(lev.ex-lev.min))*
gl.page.prop);

if(gl.colts==ON)
{
pscolour(outmain_f.fp,gl.palette.tsid[m]);
psbox2(outmain_f.fp,2,xlo,xhi,0,boxwid);
pscolour(outmain_f.fp,coll.colts);
}


iv= 0;
while(iv<TSVALN)
{

itscal= (ts.val[n]<TSVALN?ts.val[n]+1:7);

if(strstr(ts.lab+n*TSVALN,"Tbs")==NULL
&&strstr(ts.lab+n*TSVALN,"Tb")==NULL)
{
pstrcpy(tssym,ts.lab+n*TSVALN,5);
}
else
{

rtn= sprintf(tssym,"%s%d",ts.lab+n*TSVALN,ts.val[n]);
assert(rtn>0&&rtn<5);
itscal= 3;
}

if(ts.dep[m]>lev.min&&ts.dep[m]<=lev.ex&&lastdep!=lev.ex)
{

PSOPER(4);


bxwid= boxwid/itscal;


fdummy1= int4(fabse(xhi-xlo)/bxwid);
bxht= fabse(xhi-xlo)/MAX((real)1,fdummy1);

PSPTRAN(gl.page.xmg+((xhi+bxht)*gl.page.high),0);
PSROT(ANG);


PSSCALE(bxwid*gl.page.wide/28,bxht*gl.page.high/28);

PSPEN(0.0);

l= 0;
for(;;)
{

iy= l%itscal;
if(l>0&&iy<1)
{
PSPTRAN(-(real)iyy,-28);
if(iyy==28*(itscal+1))PSPTRAN(14,0);
if(iy>0)PSPTRAN((real)iy*28,0);
}
iyy= iy*28;

PSSYM(tssym);
iyy+= 28;

if(++l>int4((fabse(xhi-xlo)/bxht)*itscal)-1)break;

}

PSOPER(5);

}

iv+= ts.val[n];
n++;

}

pslineto(1,xlo,0,0,boxwid);

xhi= xlo;

}


PSOPER(5);

PSPEN(10*coll.penwid);
pscolour(outmain_f.fp,gl.palette.fore);


pstran(0,gl.page.ts+(gl.page.sep/2));

return;
}


/*:16*//*18:*/
#line 701 "ppfuncx2.w"

void pszoncol_x
(
const char*const szonhead,
const zone_t zon,
const frame_t coll,
const samp_t lev
)

{
real azonmax= 0;
real azonmin= 0;
real fdummy1= 0;
real fdummy2= 0;
real leng= 0;
real xhi= 0;
real xlev= 0;
real xlo= 0;
real yy= 0;

loop_t i= 0;
loop_t j= 0;
loop_t k= 0;

PSCOMM("n Zone");


for(k= 0;k<zon.num;k++)
{


azonmin= zon.dep[k];
azonmax= zon.dep[k+1];
if(azonmin<=lev.max&&azonmax>=lev.min)
{
azonmin= MAX(azonmin,lev.min);
azonmax= MIN(azonmax,lev.max);
xhi= xlo= DIAGOFF;
xhi+= ((azonmin-lev.min)/(lev.ex-lev.min))*gl.page.prop;
xlo+= ((azonmax-lev.min)/(lev.ex-lev.min))*gl.page.prop;



leng= strwid(zon.lab[k]);
fdummy1= ((xlo+xhi)/2)+gl.page.lineht/2;
fdummy2= gl.page.sep+((gl.page.zon-gl.page.sep)/2)-(leng/2);


if(gl.colzone==ON)
{
pscolour(outmain_f.fp,gl.palette.zoneid[k]);
psbox2(outmain_f.fp,2,xlo,xhi,0,gl.page.zon);
pscolour(outmain_f.fp,gl.palette.fore);
}

pscolour(outmain_f.fp,coll.colzone);
pstext(outmain_f.fp,6,fdummy1,fdummy2,zon.lab[k],"F2",ANG);
pscolour(outmain_f.fp,gl.palette.fore);

}

}


for(j= 0;j<zon.num-1;j++)
{
if(zon.dep[j+1]<=lev.max&&zon.dep[j+1]>=lev.min)
{
xlev= DIAGOFF+((zon.dep[j+1]-lev.min)/(lev.ex-lev.min))*
gl.page.prop;
yy= gl.page.yscbeg+(2*gl.page.sep)+gl.page.ts+gl.page.c14+
gl.page.time;


pscolour(outmain_f.fp,coll.colzone);
if(!coll.indspl)
{
PSCOMM("i");

PSDASH(50,50);

fdummy1= yy-gl.page.ylo;
fdummy2= gl.page.ylo+gl.page.sep;
if(gl.page.nysum==0)
{
pslineto(1,xlev,fdummy1,0,fdummy2-yy);
}
else
{
pslineto(1,xlev,fdummy1,0,gl.page.ysumlo[0]-yy);
for(i= 0;i<gl.page.nysum-1;i++)
{
pslineto(1,xlev,fdummy1+(gl.page.ysumhi[i]-yy),0,
gl.page.ysumlo[i+1]-gl.page.ysumhi[i]);
}
pslineto(1,xlev,gl.page.ysumhi[i]-gl.page.ylo,0,
fdummy2-gl.page.ysumhi[i]);
}


PSNODASH;

PSCOMM("j");

}

pslineto(1,xlev,gl.page.sep,0,gl.page.zon-gl.page.sep);
pscolour(outmain_f.fp,gl.palette.fore);

}

}

pscolour(outmain_f.fp,coll.colzone);
psbox(1,DIAGOFF+gl.page.prop,DIAGOFF,gl.page.zon,gl.page.sep);

xlev= DIAGOFF;
if(zon.dep[0]>lev.min)
{
xlev+= ((zon.dep[0]-lev.min)/(lev.ex-lev.min))*gl.page.prop;
pslineto(1,xlev,gl.page.sep,0,gl.page.zon-gl.page.sep);
}

if(zon.dep[zon.num]<lev.max)
{
xlev+= ((zon.dep[zon.num]-lev.min)/(lev.ex-lev.min))*
gl.page.prop;
pslineto(1,xlev,gl.page.sep,0,gl.page.zon-gl.page.sep);
}
pscolour(outmain_f.fp,gl.palette.fore);

pstext(outmain_f.fp,6,NAMEOFF,gl.page.sep,szonhead,"F2",ANG+coll.rot);


pstran(0,gl.page.zon+gl.page.sep);

return;
}


/*:18*//*20:*/
#line 848 "ppfuncx2.w"

void xscale_x
(
const frame_t coll,
frame_t*const ind,
const int itaxty,
const int raresam,
const char*const exstring,
real*const allj,
real*const endfn,
char sunit[12][LENSTR/2]
)

{
static char text[LENSTR2]= "";

real a= 0;
real factor= 1;
real fdummy1= 0;
real fdummy2= 0;
real leng= 0;

int imin= 0;
int magsc= 0;
int markint= 0;


pscolour(outmain_f.fp,ind->colxax);

buffer_f[0]= '\0';

if(gl.page.minpl>1.6e-3)markint= 10;
else if(gl.page.minpl>8e-4)markint= 20;
else markint= 40;

if(ind->indscale==ON||coll.label==ON)
{


if(itaxty=='!')
{
rtn= sprintf(buffer_f,"%d",raresam);
assert(rtn>0&&rtn<LENSTR2);
}
else if(coll.label==ON)pstrcpy(buffer_f,exstring,LENSTR2-1);

magsc= int2(log10e(1/ind->scale));
if(magsc==-1)
{
factor= 0.1;
magsc= 0;
}


if(!coll.indscale&&ind->indscale&&coll.scale==ind->scale)
{
magsc= -INT_MAX;
}

if(coll.label&&magsc==0)magsc= -INT_MAX;

pstrcpy(text,getlabel_s(itaxty,magsc,buffer_f,&leng,sunit),LENSTR2);
fdummy1= DIAGOFF+gl.page.prop+LABLOFF;
pstext(outmain_f.fp,6,fdummy1,0,text,"F2",ANG);
*endfn= leng+strwid(" ");

ind->max= MAX(ind->max,(*endfn/gl.page.minpl));
*allj= ind->max-ind->min;

}



if(gl.tufte==OFF)
{
fdummy1= DIAGOFF+gl.page.prop+LINEOFF;
pslineto(1,fdummy1,gl.page.minpl*ind->min,0,gl.page.minpl*(*allj));
}
else
{
fdummy1= DIAGOFF+gl.page.prop+LINEOFF/3;

pslineto(1,fdummy1,gl.page.minpl*ind->datamin,0,
gl.page.minpl*(ind->lq-ind->datamin));

PSCIRCLE(fdummy1,gl.page.minpl*ind->median,25);

pslineto(1,fdummy1,gl.page.minpl*ind->uq,0,
gl.page.minpl*(ind->datamax-ind->uq));
}

imin= (int)(ind->min/10)*10;
while((real)imin<=ind->max)
{
if((real)imin>=ind->min)
{
a= (real)imin*gl.page.minpl;


rtn= sprintf(text,"%.1f",(real)imin*factor/ind->finscale);
assert(rtn>0&&rtn<LENSTR2);
if(strstr(text,".0")!=NULL)text[pstrlen(text)-2]= '\0';



if((gl.tufte==OFF&&ind->max-(real)imin>2.5)||
(gl.tufte==ON&&(real)imin>0.0))
{
leng= strwid(text);
fdummy1= DIAGOFF+gl.page.prop+ANNOOFF;
pstext(outmain_f.fp,6,fdummy1,a-(leng/2),text,"F2",ANG);
}

fdummy1= DIAGOFF+gl.page.prop+LINEOFF;
pslineto(0,fdummy1,a,-MARKLEN,0);

}

if(((real)imin+(real)markint/2)<=ind->max&&
((real)imin+(real)markint/2)>=ind->min)
{

fdummy1= DIAGOFF+gl.page.prop+LINEOFF;
fdummy2= a+gl.page.minpl*markint/2;
pslineto(0,fdummy1,fdummy2,-MARKLEN/2,0);
}
PSOPER(3);

imin+= markint;

}


pscolour(outmain_f.fp,gl.palette.fore);

return;
}
/*:20*/
