/*36:*/
#line 104 "ppmain.w"

#include "psimpoll.h"
#include "ppmain.h" 
#include "ppmainx1.h" 
#define PPMAIN
#include "ppps.h" 

#define INITGLOBAL
#include "ppglobal.h" 

/*:36*//*37:*/
#line 115 "ppmain.w"

char**scline_f= NULL;
char**sclineb_f= NULL;
char**sclinec_f= NULL;


/*:37*//*38:*/
#line 122 "ppmain.w"

file_t inmain_f= 
{
"",NULL,CLOSED,"r"
};

file_t outmain_f= 
{
"",NULL,CLOSED,"w"
};


/*:38*//*39:*/
#line 135 "ppmain.w"

char buffer_f[LENSTR2]= "";

/*:39*//*41:*/
#line 143 "ppmain.w"

int main
(
int argc,
char*argv[]
)

{
/*:41*//*42:*/
#line 152 "ppmain.w"

static char buffer[LENSTR2]= "";
static char sunit[12][LENSTR/2]= 
{
" grains cm{-3}",
" grains g{-1}",
" grains cm{-2} year{-1}",
" cm{2} cm{-3}",
" cm{2} cm{-2} year{-1}",
" cm{2} g{-1}",
" cm{2} grain{-1}",
" cent.{-1}",
" ratio",
" power",
"",
""
};

static char title[LENSTR2]= "";

flag_t intfg= OFF;
flag_t ipdat= OFF;
flag_t newpge= OFF;
flag_t flag= OFF;
format_t ipform= PSIMPOLL;

int iex= 0;
int ipge= 0;
int nnsam= 0;
int nntax= 0;
int nosm= 0;

letter_t drive= 0;

int nchar= 0;

loop_t i= 0;
loop_t ii= 0;
loop_t j= 0;
loop_t jj= 0;
loop_t k= 0;
loop_t kk= 0;

real asize= 250.0F/7.1F;

age_t age= 
{
OFF,OFF,0,50,0,50,1,0,1,OFF
};

ci_t ci= {OFF,OFF,1,100,0};

file_t agedep= 
{
"",NULL,CLOSED,"w"
};

file_t adplot= 
{
"",NULL,CLOSED,"w"
};

file_t cfg= 
{
"",NULL,CLOSED," "
};

file_t colour= 
{
"psimpoll.COL",NULL,CLOSED,"r"
};

file_t dat= 
{
"",NULL,CLOSED,"w"
};

file_t inage= 
{
"",NULL,CLOSED,"r"
};

file_t ints= 
{
"",NULL,CLOSED,"r"
};

file_t script= 
{
"",NULL,CLOSED," "
};

file_t stat= 
{
"",NULL,CLOSED,"w"
};

file_t zone= 
{
"",NULL,CLOSED," "
};

four_t four= 
{
OFF,0
};

frame_t coll= 
{
OFF,OFF,OFF,0.5,OFF,OFF,OFF,OFF,OFF,OFF,OUTL,0,PLAIN,1,1,0,
0,OFF,45,0,SCRWRITE,OFF,0,0,0,0,0,0,ON,OFF,0L,0L,0L,
0L,0L,0L,0L,0L,1.0
};

frame_t agerange= 
{
OFF,OFF,OFF,0.5,OFF,OFF,OFF,OFF,OFF,OFF,OUTL,0,PLAIN,1,1,0,
0,OFF,45,0,SCRWRITE,OFF,0,0,0,0,0,0,ON,OFF,0L,0L,0L,
0L,0L,0L,0L,0L,1.0
};

samp_t lev= 
{
OFF,0,0,0,0,0,0,ON,0,0,0,0,1.0,0.0,0.0,PAIR
};

num_t num= {0,OFF};

ca_t ca= 
{
OFF,0,{OFF,10},OFF,OFF,4,OFF,26,0.0
};

pca_t pca= 
{
OFF,3,6,0,{OFF,10}
};

rare_t rarer= {OFF,0};

static roc_t roc= 
{
OFF,1,0,
{
"","Chord distance","Information statistic",
"Chi-squared coefficient 1","Chi-squared coefficient 2",
"Manhattan metric","Euclidian distance","Angular separation",
"Standardized Euclidian distance"
},
{OFF,10},
};


zoner_t zoner= 
{
OFF,10,1,"",0,OFF,{OFF,10}
};

/*:42*//*43:*/
#line 311 "ppmain.w"

caption_t head= 
{
NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
};

data_t data= 
{
0,0,"",NULL,NULL,NULL,NULL,NULL,NULL,
{NULL,NULL,NULL,NULL,NULL},NULL,{NULL,1,NULL,NULL},NULL
};

rc14_t c14= 
{
0,0,NULL,NULL,NULL,NULL
};

sed_t sed= {NULL,NULL};

ts_t ts= {0,NULL,NULL,NULL};

xaxis_t xsamp= {0,NULL,NULL,0};
xaxis_t xtime= {0,NULL,NULL,0};

zone_t zon= {0,NULL,NULL};

flag_t*bigtax= NULL;

real*rsum= NULL;

real**smdat= NULL;

int*nsum= NULL;

/*:43*//*44:*/
#line 346 "ppmain.w"

(void)signal(SIGABRT,&handler);
(void)signal(SIGILL,&handler);
(void)signal(SIGINT,&handler);
(void)signal(SIGFPE,&handler);
(void)signal(SIGSEGV,&handler);
(void)signal(SIGTERM,&handler);

errno= 0;

/*:44*//*45:*/
#line 357 "ppmain.w"

gl.clockstart= clock();

/*:45*//*46:*/
#line 361 "ppmain.w"

ATEXIT(&ppend);

/*:46*//*47:*/
#line 365 "ppmain.w"

#ifdef MPWOLD
rtn= setvbuf(stdout,(char*)NULL,_IONBF,BUFSIZ);
assert(rtn==0);
#endif

/*:47*//*48:*/
#line 372 "ppmain.w"

pstrcpy(gl.prog,"psimpoll",10);
gl.ver= 3.10F;
pstrcpy(gl.logf.fname,"psimpoll.LOG",LENFNAME);
lev.max= -FLT_MAX;
lev.min= FLT_MAX;

/*:48*//*49:*/
#line 380 "ppmain.w"

if((gl.logf.fp= fopen(gl.logf.fname,gl.logf.mode))==NULL)PPERROR(8);
gl.logf.st= OPEN;
#ifdef MPWOLD
rtn= setvbuf(gl.logf.fp,(char*)NULL,_IONBF,BUFSIZ);
assert(rtn==0);
#endif
rtn= fprintf(gl.logf.fp,"%s\n",getctime());
assert(rtn>0);

/*:49*//*50:*/
#line 391 "ppmain.w"

CHECKTIME;

/*:50*//*51:*/
#line 395 "ppmain.w"

scline_f= amatchar(SCRHT,SCRWID);
sclineb_f= amatchar(SCRHT,SCRWID);
sclinec_f= amatchar(SCRHT,SCRWID);

pstrcpy(scline_f[SCRHT-1],"> ",SCRWID);
pstrcpy(sclineb_f[SCRHT-1],scline_f[SCRHT-1],SCRWID);
pstrcpy(sclinec_f[SCRHT-1],scline_f[SCRHT-1],SCRWID);

/*:51*//*52:*/
#line 405 "ppmain.w"

rtn= printf("%s %.2f Copyright (c) 1993, 1998 K.D. Bennett\n",gl.prog,gl.ver);
assert(rtn>0);

/*:52*//*53:*/
#line 410 "ppmain.w"

if(argc>=2)pstrcpy(inmain_f.fname,argv[1],LENFNAME);
else
{
rtn= puts("Enter name of file with data");
assert(rtn!=EOF);
gets(inmain_f.fname);
}

getfnames_x(&outmain_f,&cfg,&script,&zone,&inage,&ints,&stat,&dat,
&agedep,&adplot,&drive);

openf(&inmain_f,__FILE__,__LINE__,ON);

/*:53*//*54:*/
#line 425 "ppmain.w"

begindata_x(&data,title,&iex,&head,&ci,&coll,&lev,&age,&num);

/*:54*//*55:*/
#line 429 "ppmain.w"

rtn= sprintf(zoner.pre,"%c-",
pstrlen(data.intitle)!=0?data.intitle[0]:'?');
assert(rtn>0&&rtn<30);

/*:55*//*56:*/
#line 435 "ppmain.w"

xsamp.ntick= data.nsam;
if(gl.code.yax!='T'&&gl.code.yax!='S')xsamp.ntick*= 10;
xsamp.val= avecreal(xsamp.ntick);
xsamp.annot= amatchar(xsamp.ntick,XLABLEN);

xtime.ntick= data.nsam;
if(gl.code.yax!='T'&&gl.code.yax!='S')xtime.ntick*= 10;
xtime.val= avecreal(xtime.ntick);
xtime.annot= amatchar(xtime.ntick,XLABLEN);

for(i= 0;i<xtime.ntick;i++)
{
xtime.annot[i][0]= xsamp.annot[i][0]= '\0';
}

/*:56*//*57:*/
#line 452 "ppmain.w"

pstrcpy(scline_f[1],data.intitle,SCRWID);
rtn= sprintf(scline_f[3],"%d taxa  %d samples",data.ntax,data.nsam);
assert(rtn>0&&rtn<SCRWID);

for(i= 0;i<4;i++)
{
pstrcpy(sclineb_f[i],scline_f[i],SCRWID);
pstrcpy(sclinec_f[i],scline_f[i],SCRWID);
}
rtn= fprintf(gl.logf.fp,
"Title: %s\nNumber of taxa: %d\nNumber of samples: %d\n",data.intitle,
data.ntax,data.nsam);
assert(rtn>0);

/*:57*//*58:*/
#line 468 "ppmain.w"


openf(&colour,__FILE__,__LINE__,OFF);
if(colour.st==OPEN)
{
i= 0;
buffer[0]= '\0';
while(feof(colour.fp)==0)
{
pstrcpy(buffer_f,getbuf(&colour,"\n"),LENSTR2);
if(buffer_f[0]!='#')
{
if(flag==OFF)

{
gl.palette.n= atol(buffer_f);
gl.palette.id= aveclong(gl.palette.n);
gl.palette.val= amatreal(4,gl.palette.n);
gl.palette.name= amatchar(gl.palette.n,LENTAXN);
flag= ON;
}
else
{
nchar= 0;
while(isdigit(buffer_f[nchar])!=0||buffer_f[nchar]=='.')
{
buffer[nchar]= buffer_f[nchar];
nchar++;
}
buffer[nchar]= '\0';
gl.palette.id[i]= atol(buffer);
for(ii= 0;ii<4;ii++)
{
while(isdigit(buffer_f[nchar])==0)nchar++;
gl.palette.val[ii][i]= atof(buffer_f+(nchar-1));
while((isdigit(buffer_f[nchar])!=0||buffer_f[nchar]=='.')
&&buffer_f[nchar]!='\0')
{
nchar++;
}
}
while(isspace(buffer_f[nchar])!=0)nchar++;
ii= 0;
while(ii<LENTAXN-1&&nchar<LENSTR2-1)
{
if(isprint(buffer_f[nchar])!=0)buffer[ii++]= buffer_f[nchar];
nchar++;
}
buffer[ii]= '\0';
pstrcpy(gl.palette.name[i],buffer,LENTAXN);
i++;
if(i>=gl.palette.n)break;
}

}

}

}

buffer[0]= '\0';

i= 0;

/*:58*//*59:*/
#line 533 "ppmain.w"

readcfg_x(&cfg,&coll,&agedep,&adplot,&outmain_f,&head,&agerange,
&intfg,&age,&zone,&inage,&ints,&ci,&rarer,&zoner,&four,&num,
&roc,&stat,&dat,&pca,&ca,&lev,&ipdat,&ipform,sunit);

if(data.ntax>237)intfg= OFF;

if(colour.st==CLOSED)
{
gl.palette.fore= 0L;
gl.palette.back= 1L;
gl.colts= OFF;
gl.colzone= OFF;
coll.colpl= coll.coltit= coll.coldep= coll.col14c= coll.colts= 
coll.colzone= coll.colxax= 0L;
}
else closef(&colour,__FILE__,__LINE__);

/*:59*//*60:*/
#line 552 "ppmain.w"

chkfname_x(&agedep,drive);
chkfname_x(&adplot,drive);
chkfname_x(&outmain_f,drive);
chkfname_x(&zone,drive);
chkfname_x(&inage,drive);
chkfname_x(&ints,drive);
chkfname_x(&stat,drive);
chkfname_x(&dat,drive);

/*:60*//*61:*/
#line 564 "ppmain.w"

if(age.flag==ON)
{
gl.code.yax= 'A';
gl.flag[TS]= OFF;
}

/*:61*//*62:*/
#line 572 "ppmain.w"

if(gl.tufte==ON)
{
ci.flag= ON;
}

/*:62*//*63:*/
#line 579 "ppmain.w"

menu(cfg,&coll,&agedep,&adplot,&outmain_f,&head,&intfg,&age,&zone,
&inage,&ints,&ci,&rarer,&zoner,&four,&num,&roc,&stat,&agerange,
&dat,&pca,&ca,&lev,&ipdat,&ipform,sunit,data.nsam,data.ntax,
argc);

/*:63*//*64:*/
#line 586 "ppmain.w"

fmatchar(sclineb_f,SCRHT);
fmatchar(sclinec_f,SCRHT);

/*:64*//*65:*/
#line 592 "ppmain.w"

if(gl.font.ufac>0)gl.font.fac= gl.font.ufac;
gl.page.charsc= (0.250/gl.page.wide)*(gl.font.fac/7.1);
gl.page.lineht= 1000*gl.page.charsc;
gl.adpage.charsc= (0.250/gl.adpage.wide)*(gl.font.fac/7.1);
gl.adpage.lineht= gl.adpage.lineht= 1000*gl.adpage.charsc;

if(ci.flag==ON)ci.adflag= ON;

/*:65*//*66:*/
#line 602 "ppmain.w"

title[0]= '\0';
vstrcat(LENSTR2,title,data.intitle,"  #",head.subtitle,(char*)NULL);

/*:66*//*67:*/
#line 608 "ppmain.w"


gl.page.ymg= (gl.papwid-gl.page.high)*0.5F;
gl.page.xmg= (gl.papht-gl.page.wide)*0.5F;
gl.adpage.ymg= (gl.papwid-gl.adpage.high)*0.5F;
gl.adpage.xmg= (gl.papht-gl.adpage.wide)*0.5F;

/*:67*//*68:*/
#line 616 "ppmain.w"

logpage_x();

/*:68*//*69:*/
#line 620 "ppmain.w"

if(pstrlen(zone.fname)==0)gl.flag[ZONE]= OFF;
if(pstrlen(inage.fname)==0)
{
gl.flag[C14]= OFF;
age.timx= OFF;
}
if(pstrlen(ints.fname)==0)gl.flag[TS]= OFF;

/*:69*//*70:*/
#line 630 "ppmain.w"

gl.idum= (strcmp(gl.seed,"TIMER")==0)?getsecs_x():atol(gl.seed);
srand((unsigned)gl.idum);
TOLOGL(gl.idum);

/*:70*//*71:*/
#line 636 "ppmain.w"

if(rarer.flag==ON)data.ntax++;

/*:71*//*72:*/
#line 640 "ppmain.w"

if(roc.flag==ON)data.ntax++;

/*:72*//*73:*/
#line 644 "ppmain.w"

data.alev= avecfloat(data.nsam);
data.alevold= avecfloat(data.nsam);
data.levfg= avecflag_t(data.nsam);
data.dat= amatfloat(data.ntax+EXTRATAXN,data.nsam);
data.histwid= avecreal(data.nsam);

gl.page.ysumlo= avecreal(NSUM);
gl.page.ysumhi= avecreal(NSUM);

data.taxname= amatchar(data.ntax+EXTRATAXN,LENTAXN);
nsum= avecint(MAXSUM);

/*:73*//*74:*/
#line 659 "ppmain.w"


data.exlabel= amatchar(data.ntax,LENTAXN);
data.summary.name= amatchar(MAXSUM,LENTAXN);

/*:74*//*75:*/
#line 665 "ppmain.w"

rtn= printf("Reading main data set ..");
assert(rtn>0);

if(gl.input==TILIA)
{
gettildata_x(&data,&lev,coll,&rarer,roc,&xsamp,intfg,&nosm,&nnsam,
nsum,age.flag,age.adbc);
}
else
{
getpsidata_x(&data,&lev,coll,&rarer,roc,&xsamp,intfg,&nosm,&nnsam,
nsum,age.flag,age.adbc);
}


if(gl.code.dat=='%'&&ci.flag==ON&&nosm==0)
{

dprint(&gl.logf,"\nNo sum found to calculate confidence intervals\n"
"Taxa will be plotted without confidence intervals\n");
ci.flag= OFF;
}

if(feof(inmain_f.fp)!=0&&ci.flag==ON&&
(gl.code.dat=='C'||gl.code.dat=='B'))
{

dprint(&gl.logf,"\nNo data found to calculate confidence intervals\n"
"Taxa will be plotted without confidence intervals\n");
ci.flag= OFF;
}

/*:75*//*76:*/
#line 699 "ppmain.w"

if(ci.flag==ON)
{
coll.style= OUTL;
coll.curve= CONFIN;
}

/*:76*//*77:*/
#line 707 "ppmain.w"

if(ci.flag==ON&&(gl.code.dat=='C'||gl.code.dat=='B'))
{
data.conc.ex= amatreal(iex,data.nsam);
data.conc.lgmv= avecreal(data.nsam);
data.conc.lgsmv= avecreal(data.nsam);
data.conc.mv= avecreal(data.nsam);
data.conc.mvsd= avecreal(data.nsam);

getabsdata_x(&data,iex,ci.meth);
}

/*:77*//*78:*/
#line 720 "ppmain.w"

closef(&inmain_f,__FILE__,__LINE__);
rtn= puts(". done");
assert(rtn!=EOF);

/*:78*//*79:*/
#line 726 "ppmain.w"

if(gl.flag[C14]==ON)getc14_x(&age,inage,ints,&c14);

/*:79*//*80:*/
#line 730 "ppmain.w"

if(agedep.fname[0]=='\0')gl.flag[AD]= OFF;
else if(gl.flag[AD]==ON)
{
openf(&agedep,__FILE__,__LINE__,OFF);
if(agedep.st==CLOSED)gl.flag[AD]= OFF;
if(gl.flag[AD]==ON)
{
rtn= fprintf(agedep.fp,"%s\n",data.intitle);
assert(rtn>0);
}

}

/*:80*//*81:*/
#line 745 "ppmain.w"

if(age.flag==ON||age.timx==ON||gl.code.dat=='B')
{
agedepth(&agedep,&adplot,&data,&age,ci,c14,&sed,&lev,&xsamp,
&xtime,asize,head,&agerange);
}

/*:81*//*82:*/
#line 753 "ppmain.w"

if(gl.code.dat=='B')
{
getaccrate_x(data,data.ntax+(int)rarer.flag+(int)roc.flag,sed,age);
}

/*:82*//*83:*/
#line 760 "ppmain.w"

closef(&agedep,__FILE__,__LINE__);

rtn= fputs("Contents of samp_t lev (l):\n",gl.logf.fp);
assert(rtn!=EOF);
loglev(lev);

/*:83*//*84:*/
#line 768 "ppmain.w"

getts_x(ints,&ts);

/*:84*//*85:*/
#line 772 "ppmain.w"

openf(&stat,__FILE__,__LINE__,OFF);
if(stat.st==CLOSED)
{

coll.indspl= four.flag= num.stat= pca.flag= ca.flag= OFF;
if(stat.fname!=NULL)
{
dprint(&gl.logf,"File for results of data analysis is not "
"available\n");
}
}
else
{
rtn= fprintf(stat.fp,"%s\nMain input file: %s\n",data.intitle,
inmain_f.fname);
assert(rtn>0);
}

/*:85*//*86:*/
#line 792 "ppmain.w"


for(j= 0;j<data.nsam;j++)
{
if(data.levfg[j]==OFF)continue;
if(data.alev[j]<(float)lev.min||data.alev[j]>(float)lev.max)
{
nnsam--;
data.levfg[j]= OFF;
continue;
}

}

if(nnsam<=0)derror(18);

/*:86*//*87:*/
#line 809 "ppmain.w"

if((stat.st==OPEN||zoner.flag==ON||roc.flag==ON)&&
(roc.flag==ON||num.stat==ON||pca.flag==ON||four.flag==ON||
zoner.flag==ON||ca.flag==ON))
{
bigtax= avecflag_t(data.ntax+rarer.flag+roc.flag);






findtax_x(&nntax,data,bigtax,num.thresh,
data.ntax+rarer.flag+roc.flag);






smdat= amatreal(nntax+2,nnsam+1);

if(gl.recalc==ON)rsum= avecreal(nnsam);


jj= j= 0;
while(jj<data.nsam)
{

for(k= 0,kk= 0;k<data.ntax+rarer.flag+roc.flag;k++)
{
if(bigtax[k]==OFF)continue;


if(jj==data.nsam-1)smdat[kk][nnsam]= k;

if(data.levfg[jj]==ON)
{
if(data.dat[k][jj]>=(float)0)smdat[kk][j]= (real)data.dat[k][jj];
else
{
smdat[kk][j]= 0;
dprint(&gl.logf,"\nDataset includes a value of %f: "
"converted to 0\n",(double)data.dat[k][jj]);
}

if(gl.recalc==ON)rsum[j]+= smdat[kk][j];

}

kk++;

}

if(data.levfg[jj]==ON)
{

smdat[nntax][j]= (real)data.alev[jj];
if(data.alevsd!=NULL)smdat[nntax+1][j]= data.alevsd[jj];
j++;

}

jj++;

}

if(gl.recalc==OFF)
{
dprint(&stat,
"Dataset for analyses not recalculated as proportions\n");
}
else
{

for(j= 0;j<nnsam;j++)
{
for(kk= 0;kk<nntax;kk++)smdat[kk][j]/= rsum[j];
}

dprint(&stat,"Dataset for analyses recalculated as proportions\n");

}

if((roc.model.ci==ON||pca.model.ci==ON||ca.model.ci==ON||
zoner.model.ci==ON)&&(gl.code.dat!='%'||nosm==0))
{
dprint(&gl.logf,"Modelling of zonation, pca, ca, or rate of change requires"
" that data be input as\nproportions and that data sums are "
"available. Modelling cannot be done\nwith the data available\n");
pca.model.ci= OFF;
ca.model.ci= OFF;
roc.model.ci= OFF;
zoner.model.ci= OFF;
}

if((roc.model.ci==ON||pca.model.ci==ON||ca.model.ci==ON||
zoner.model.ci==ON)&&gl.recalc==ON)
{

for(j= 0;j<nnsam;j++)rsum[j]*= (real)data.dat[nsum[0]][j];
}

if(stat.fp!=NULL)
{

rtn= fprintf(stat.fp,"%d taxa  %d levels\n\n",nntax,nnsam);
assert(rtn>0);
}

fvec(bigtax);

}


/*:87*//*88:*/
#line 925 "ppmain.w"

if(coll.interp==ON)
{
interp_x(&data,&lev,&stat);
}


/*:88*//*89:*/
#line 933 "ppmain.w"

if(zoner.flag==ON)
{
if(zoner.n==0)zoner.model.ci= OFF;
while(zoner.model.ci&&zoner.model.n>0)
{
if(zoner.meth==5)
{
coniss(zoner,nnsam,nntax,smdat,rsum,&zone,&stat);
}
else zonation(zoner,nnsam,nntax,smdat,rsum,&zone,&stat);
zoner.model.n--;

}

zoner.model.ci= OFF;

if(zoner.meth==5)
{
coniss(zoner,nnsam,nntax,smdat,(real*)NULL,&zone,&stat);
}
else zonation(zoner,nnsam,nntax,smdat,(real*)NULL,&zone,&stat);

}

/*:89*//*90:*/
#line 959 "ppmain.w"

getzone_x(zone,&zon);


if(gl.flag[ZONE]==ON)
{
zon.dep[0]= (real)data.alev[lev.minpos]-data.histwid[lev.minpos];
zon.dep[zon.num]= (real)data.alev[lev.maxpos]+data.histwid[lev.maxpos];
}

/*:90*//*91:*/
#line 970 "ppmain.w"

if(rarer.flag==ON)
{
raref(&rarer,&data,nsum[0],roc.flag);
}

/*:91*//*92:*/
#line 977 "ppmain.w"

if(roc.flag==ON)
{
if(age.flag==ON||gl.code.yax=='A')
{
dprint(&stat,"\n\nRate-of-change analysis\n");

while(roc.model.ci==ON&&roc.model.n>0)
{
rocer(roc,smdat,rsum,&data,nnsam,nntax,&stat);
roc.model.n--;
}

roc.model.ci= OFF;

rocer(roc,smdat,(real*)NULL,&data,nnsam,nntax,&stat);
if(roc.smooth==ON)
{
dprint(&stat,"Dataset for rate-of-change analysis smoothed\n");
}


vstrcat(LENSTR,buffer,"=",roc.text[roc.diss],(char*)NULL);
if(pstrlen(buffer)+1>LENTAXN)
{
data.taxname[data.ntax-1]= rvecchar(data.taxname[data.ntax-1],
pstrlen(buffer)+1);
}
pstrcpy(data.taxname[data.ntax-1],buffer,
MAX(LENTAXN,pstrlen(buffer)+1));

}

else
{
dprint(&gl.logf,"Rate-of-change analysis requested, but sample age "
"data is not available\nAnalysis not carried out\n");
roc.flag= OFF;
pstrcpy(data.taxname[data.ntax-1],"VOID",LENTAXN);
}

}

/*:92*//*93:*/
#line 1021 "ppmain.w"

if(num.stat==ON)stater(smdat,nnsam,nntax,data.taxname,&stat);

/*:93*//*94:*/
#line 1025 "ppmain.w"

if(pca.flag==ON)
{

while(pca.model.ci==ON&&pca.model.n>0)
{
pcaer(pca,nnsam,nntax,smdat,rsum,data.taxname,&stat);
pca.model.n--;
}

pca.model.ci= OFF;
pcaer(pca,nnsam,nntax,smdat,(real*)NULL,data.taxname,&stat);

}


/*:94*//*95:*/
#line 1042 "ppmain.w"


if(ca.flag==ON)
{

while(ca.model.ci==ON&&ca.model.n>0)
{
caer(ca,nnsam,nntax,smdat,rsum,data.taxname,&stat);
ca.model.n--;
}

ca.model.ci= OFF;
caer(ca,nnsam,nntax,smdat,(real*)NULL,data.taxname,&stat);

}


/*:95*//*96:*/
#line 1060 "ppmain.w"

if(four.flag==ON)
{

fourer(four,nnsam,nntax,smdat,NULL,data.taxname,data.intitle,&stat);
}

/*:96*//*97:*/
#line 1068 "ppmain.w"

if(ipdat==ON)
{
openf(&dat,__FILE__,__LINE__,OFF);
if(dat.st==CLOSED)
{
ipdat= OFF;
if(dat.fname!=NULL)
{
dprint(&gl.logf,"File for data output is not available\n");
}
}

switch(ipform)
{
case PSIMPOLL:
mkdapsim_x(&dat,data,xsamp,rarer,coll);
break;
case CORNELL:
mkdacorn_x(&dat,data,xsamp,age);
break;
}

closef(&dat,__FILE__,__LINE__);

}

/*:97*//*98:*/
#line 1096 "ppmain.w"

fvec(rsum);
fmatreal(smdat,nntax+2);

/*:98*//*99:*/
#line 1101 "ppmain.w"

obtdmax_x(data,&coll);

/*:99*//*100:*/
#line 1105 "ppmain.w"

openf(&outmain_f,__FILE__,__LINE__,ON);

psinit(outmain_f,data.intitle,asize);

psnpage1(&newpge,&ipge);
PSPEN(10.0*coll.penwid);
PSCOMM("s");

/*:100*//*101:*/
#line 1115 "ppmain.w"

plottaxa(data,lev,script,&ipge,&newpge,nsum,c14,sed,head,rarer.n,
xsamp,xtime,title,ts,zon,ci.meth,&intfg,age.timx,&stat,coll,
sunit);

/*:101*//*102:*/
#line 1121 "ppmain.w"

closef(&stat,__FILE__,__LINE__);


/*:102*//*103:*/
#line 1126 "ppmain.w"

closef(&outmain_f,__FILE__,__LINE__);

/*:103*//*104:*/
#line 1130 "ppmain.w"

fvec(ts.lab);
fvec(ts.dep);
fvec(ts.val);

fvec(data.alevsd);

fvec(c14.dp1);
fmatchar(c14.sd,c14.num);
fmatchar(c14.age,c14.num);


fvec(sed.ar);
fvec(sed.arsd);

fvec(zon.dep);
fmatchar(zon.lab,zon.num);

fvec(data.conc.mvsd);
fvec(data.conc.mv);
fvec(data.conc.lgsmv);
fvec(data.conc.lgmv);
fmatreal(data.conc.ex,iex);

fmatchar(data.summary.name,MAXSUM);
fvec(data.summary.colid);
fvec(data.summary.grey);
fmatchar(data.exlabel,data.ntax);
fvec(nsum);
fmatchar(data.taxname,data.ntax+EXTRATAXN);
fvec(gl.page.ysumhi);
fvec(gl.page.ysumlo);
fvec(data.histwid);
fmatfloat(data.dat,data.ntax+EXTRATAXN);
fvec(data.levfg);
fvec(data.alevold);
fvec(data.alev);

fmatchar(gl.palette.name,gl.palette.n);
fmatreal(gl.palette.val,4);
fvec(gl.palette.id);


fvec(xtime.val);
fmatchar(xtime.annot,xtime.ntick);
fvec(xsamp.val);
fmatchar(xsamp.annot,xsamp.ntick);

fvec(head.subtitle);
fvec(head.zone);
fvec(head.sed);
fvec(head.time);
fvec(head.ps2);
fvec(head.ps1);
fvec(head.c14);
fvec(head.base);

fmatchar(scline_f,SCRHT);

/*:104*//*105:*/
#line 1190 "ppmain.w"


#ifdef GCC
ppend();
#endif

return(EXIT_SUCCESS);

}
/*:105*/
